!
!  File is Functions.f90
!
!    This file contains the functions for the model.
!
! OUTPUTS: 
!
! created on 10.08.09
!
! david arthur sampson
! last write was: 02.10.12
! -------------------------
!
! =================================================================================================



           function fRelease(tier,low,mid,high,target,balance)
                real :: fRelease
                integer :: tier
                real :: low,mid,high,target
                real(8) :: balance
                    !
                    if(2 < tier)then
                        if(4 < tier)then
                            if(0 < balance)then
                              ! This seems to work
                              fRelease=max(target,min(low+balance,high))
                            else
                              ! This needs testing
                              fRelease=max(low,min(high+balance,target))
                            endif
                        else
                            ! Tier 3 and "4"
                            if(0 < balance)then
                               ! Mead < Powell;
                              fRelease=max(low,min(mid,max(target+balance,target)))
                            else
                                ! Powell < Mead
                                ! This seems to work
                               fRelease=max(low,min(high+balance,mid))
                            endif
                        endif
                    else
                     ! Tier one; min of 7 and max of 9.5 with balance
                      if(0 < balance)then
                        ! Mead < Powell; not sure on low+balance or target+balance
                        fRelease=max(low,min(high,max(target+balance,target)))
                      else
                        ! Powell < Mead
                        fRelease=max(low,min(high,min(low+balance,target)))
                      endif
                    endif
                    !
            end function fRelease
            ! -------------------



! Regression conducted on:
! 09.01.11 das
!
!NOTE: An intercept was not specified for this model.
!
!                                              Sum of        Mean               Approx
!            Source                    DF     Squares      Square    F Value    Pr > F
!
!            Model                      2      219622      109811     870.76    <.0001
!            Error                      3       378.3       126.1
!            Uncorrected Total          5      220000
!
!
!The NLIN Procedure
!
!                                                 Approx
!                   Parameter      Estimate    Std Error    Approximate 95% Confidence Limits
!
!                   a                1249.8        135.7       817.8      1681.9
!                   b                0.9983     0.000108      0.9980      0.9987
!
!
!                                 Approximate Correlation Matrix
!                                                a               b
!
!                                a       1.0000000      -0.9753574
!                                b      -0.9753574       1.000000
! Type IV exponential
!
!  Y = a * b^x
!
  ! ------------------------------------------------------------------------------------
  function fStorageRelease(state)
    !
    ! Type IV exponential function
    ! Based on a meeting that I had with Tim Skarupa, yvonne reinink, mark hubble
    ! on 09.01.11 (1 pm at ARP headquarters) There seems to be some secrecy in max and min pumping
    ! and at what volume it occurs... based on the Phillips et al. (2009) paper
    !
    real, parameter :: lpf_maxPumping=0.350
    real, parameter :: lpf_minPumping=0.075
    real, parameter :: lpf_scaling=1250
    real, parameter :: lpf_shape=0.99837
    real, parameter :: lpf_correction=14
    real, parameter :: lpf_mafTokAF=1000
    real :: fStorageRelease ! kAF
    real(8) :: state
    !
       fStorageRelease=0
      if(0.8 < state)then
        fStorageRelease=max(0,lpf_scaling*lpf_shape**(state*lpf_mafTokAF)-lpf_correction)
        if(1.6 < state)fStorageRelease=lpf_minPumping
      else 
       fStorageRelease=lpf_maxPumping*lpf_mafTokAF
      endif
    !
  end function fStorageRelease
  ! --------------------------
    ! 02.18.12 DAS
    function fModifyNormalFlow(x)
        real, parameter :: lpf_dependent=0.18420
        real, parameter :: lvf_max=5.4288
        real :: fModifyNormalFlow,x
        !
         fModifyNormalFlow=1.0
        if(0 < x)then
           fModifyNormalFlow=min(x * lpf_dependent,lvf_max)
        endif
        !
    end function fModifyNormalFlow

    function fModifyTrottNormalFlow(j,lvf_normal)
        integer :: j
        real :: lvf_normal(10),fModifyNormalFlow
        real :: fModifyTrottNormalFlow
            !
            fModifyTrottNormalFlow=fModifyNormalFlow(lvf_normal(j))
            !
    end function fModifyTrottNormalFlow
    ! ----------------------------------- 

    ! -------------------------------------------------------
          function fstates(standing,a1,a2,a3,a4,a5,s1,s2,s3,s4)
            real :: fstates
            real :: a1,a2,a3,a4,a5,s1,s2,s3,s4
            real :: standing
            ! =============
              !
              fstates=(standing+a1+a2+a3+a4+a5)-(s1+s2+s3+s4)
              !
              standing=0;a1=0;a2=0;a3=0;a4=0;a5=0;s1=0;s2=0;s3=0;s4=0
            !
          end function fstates

    ! -------------------------------------
 
  function fLogicalToInteger (truthValue)

        implicit none
       ! -----------------------

        integer :: fLogicalToInteger
        !    
        logical, intent (in) :: truthValue
        fLogicalToInteger=0
        !
        if (truthValue) then
          fLogicalToInteger = 1
        else
          fLogicalToInteger = 0
        endif
        !
   end function
! -------------------------------
  function DConvert(variable,DP)

        implicit none
        ! -----------------------

        integer DP,out
        real(8):: variable
        real :: DConvert
        real :: new,v
        !
        v=10**DP
        new=variable*v
        out=NINT(new)
        DConvert=out/v
        !
     return
    end function

! --------------------------------------------------------------------------------------


! --------------------------------------------------------------------------------------
 function fSESgpcd_bias(gvf_ReductionGPCD_pct)
    real :: fSESgpcd_bias
     real :: gvf_ReductionGPCD_pct
      real, parameter :: a=1.03935
      real, parameter :: b=0.0065
        ! bias: 1 < bias in alpha < 5
        fSESgpcd_bias=a - b*gvf_ReductionGPCD_pct
        !
    return
  end function

! --------------------------------------------------------------------------------------
  function fSESgpcd_alpha(gvf_ReductionGPCD_pct)
    real :: fSESgpcd_alpha
    real :: gvf_ReductionGPCD_pct
      real, parameter :: a=20.9630
      real, parameter :: b=0.9767
      real, parameter :: c=-0.0371
      real, parameter :: d=64.6664
        ! alpha 1 < 85 %
        fSESgpcd_alpha=a*b**gvf_ReductionGPCD_pct * gvf_ReductionGPCD_pct**c + d
        !
    return
  end function



! --------------------------------------------------------------------------------------
  function fEvaporation(state)
       !
        real(8) :: lvd_Evaporation
        real(8) :: first,second,third,state
        real(8) :: fEvaporation  ! Balaji, WRR 45 (2009) doi=10.1029/2008WR007652
        real, parameter :: b=0.3 ! 
        real, parameter :: m=0.028
       ! ===============
        !
        fEvaporation=0
        first=0.09*state
        second=first
        if(state >=0.1)then
          first=max(0.1,state *(1/4))
        else
          second=0.09*state
        endif
         !
         lvd_Evaporation=min(first,second)
         !fEvaporation=min(first,second)
         !
         third=m * state + b         ! Added on 11.04.09 by das
         !
         fEvaporation=max(lvd_Evaporation,third)
         !
    end function fEvaporation
! ------------------------------------------
  function fEvaporation_b(state)
       !
       real(8) :: state
       real(8) :: fEvaporation_b,first,second
       real(8), parameter :: a=0.5 ! maf was 0.83

       real(8), parameter :: b=0.3 ! maf 
       real(8), parameter :: m=0.028
       real, parameter :: lvf_mod=0.75

      ! ===============
       !
        fEvaporation_b=0.
       first=min(a,0.032*state)
       !
       second=m * state + b
       !
       fEvaporation_b=max(first,second)

    end function fEvaporation_b
! -------------------------------------------
  function fHorsePowerCAP(hHt,e,pumped)
        real(8):: hHt   ! head height
        real(8):: e
        real(8) :: pumped
        real(8) :: lbsperft3 = 62.4
        real(8) :: ftlbspers = 550
        real(8) :: fHorsePowerCAP
         !
         fHorsePowerCAP=0
         fHorsePowerCAP=lbsperft3*hHt*pumped * (1/(ftlbspers*e))
         !
    end function 
! -------------------------------------------
   function fKilowatthrsFromHP(hp)
        real(8):: hp
        real(8) :: kWperHP = 0.745699872
        real(8) :: fKilowatthrsFromHP
         !
         fKilowatthrsFromHP=0
         fKilowatthrsFromHP=NINT(hp*kWperHP)
         !
    end function 
! -------------------------------------------
  integer function fCftsToacftperannum(days,cft)
        integer :: days
        real(8):: cft
        !=======================
         !
         fCftsToacftperannum=NINT((cft*86400*days)* (1/43560.000627))
         !
    end function 
! -------------------------------------------
  function fAcftperannumTocfts(days,acft)
       integer :: days
       real(8) :: acft,fAcftperannumTocfts
       !=======================
        !
        fAcftperannumTocfts=0
        fAcftperannumTocfts=(acft*43560.000627)/(86400*days)

    end function
! -------------------------------------------
  function fSESgpcd(alpha,GPCD,GPCD_1,GPCD_2)
    implicit none
      real :: alpha
      real :: GPCD,GPCD_1,GPCD_2
      real(8) :: fSESgpcd
        !
        fSESgpcd=0
        ! http://www.duke.edu/~rnau/411avg.htm
        ! Brown's simple Exponential Smoothing (exponentially weighted moving average)
        ! alpha determines relative weight among observations
        ! 05.17.10 das
        fSESgpcd=alpha*(GPCD + (1.-alpha)*GPCD_1 + ((1-alpha)**2)*GPCD_2  )
        !
  end function

! -------------------------------------------
  real function fSMAgpcd(N,GPCD_1,GPCD_2,GPCD_3)
      integer :: N
      real :: GPCD_1,GPCD_2,GPCD_3
!      real, parameter :: a=0.7,b=0.2
!      real :: c
        !
        ! Simple (equaly-weighted) Moving Average
        !
!        c = 1 - (a + b)
        fSMAgpcd=(GPCD_1 + GPCD_2 + GPCD_3)* 1/N
        !
  end function
! -------------------------------------------
  function fNS_SESgpcd(alpha,year,GPCD,GPCD_1,GPCD_2)
    implicit none
      integer :: year
      real :: alpha
      real :: GPCD,GPCD_1,GPCD_2
      real(8) :: fNS_SESgpcd
        !
      fNS_SESgpcd=0
      year=year+0
      GPCD_2=0
        ! http://www.duke.edu/~rnau/411avg.htm
        ! Brown's linear exponential Smoothing model (exponentially weighted moving average)
        ! Non stationary
        ! alpha determines relative weight among observations
        ! 05.17.10 das note : yhat is for time T and not time T+1
        if(0. < GPCD_1)fNS_SESgpcd=2*GPCD - GPCD_1 - (2*(1-alpha)*exp(GPCD_1))
        !
  end function
           
! ---------------------------------------------------------------------------------------
Module gm_Euler

 implicit none
    !
    real(8), public :: y,x0
    Real(8), private :: t_0, x_0
    real(8), private :: t_f, k_j, h
    Real(8), private :: t,x
    Integer, private :: n,j
    !
    real(8), public :: outE(12)


    !
  Contains
     ! ------------------------
     ! n = number of steps
     ! h = step width (delta t)
     ! k_j = dx?
     ! t_f = delta state
     ! x0 = initial state
     ! t_0 = up dated state (new state) at the end of n steps
     ! -------------------------------------------------------
    !
    subroutine sEuler(c,t_0,x_0,t_f,n)
   
     integer, intent(in) :: n
     integer :: i,j
     real(8) :: c(12)
     real(8), intent(in) :: t_0
     real(8), intent(in) :: x_0
     real(8) :: f,t_f

      h=0
      t=0
      x=0
      do i = 1,n,1
        k_j=0
        c=0
      end do
       h=(t_f-t_0) * 1./n
       !
       x=x_0
       t=t_0
     Do j=1,n,1
      k_j=f(x)
      x=x+ (h*k_j) ! correct ??? 08.17.10 das
      t=t+h
      c(j)=t
     end do
     !
    end subroutine sEuler
End Module gm_Euler
    Function f(x)
       real(8), intent(in) :: x
       real(8) :: f
      f=2*x
      
    end function 
! -------------------------------
 subroutine ptypefiveExp(start,max,peakmonth,tfe)

   integer :: i
   real(8), parameter :: b=0.8
   real(8) :: max
   real(8) :: start
   real(8) :: peakmonth
   real(8) :: tfe(12)

   max=(max-start)
    do i = 1,12,1
     tfe(i) = start+max*b**(i-peakmonth)**2.
    end do 

 end subroutine ptypefiveExp
! -------------------------------

! -------------------------------
 subroutine gaussian(annual,Gd)

    integer :: i
    
    real(8) :: acft,annual
    real(8) :: pi
    real(8), parameter :: mu=6.5
    real(8), parameter :: sigma=1
    real(8) :: Gd(12)       ! acft month-1 outputs
    real(8) :: g
    acft=annual*1e6
    pi = atan(1.)*4.
    do i = 1,12,1
     g= ( (1/(sigma*sqrt(2*pi) ))*exp(-((i-mu)**2 * (1/(2*sigma**2)))) )
     Gd(i)=anint(g*acft)
    end do
   
 end subroutine gaussian
! -------------------------------
 function gaussianprime(a,b,flow,y)

    integer :: i
    integer :: flow
    real(8) :: a,b,pi,y(12)
    real(8) :: gaussianprime
    pi = atan(1.)*4.
    !
    do i = -6,6,1
       gaussianprime=anint(-(i-a)/sqrt(2*pi)*b**1.5 )*exp(-(i-a)**2 *(1/2*b) )
       y(i+7)=nint(gaussianprime*flow)
    end do
    !
end function gaussianprime
!MODULE IVPSolve 
! use Precision
!!...
!   subroutine Euler(f,y,n_unknowns,n_points,dx,x0,y0)
!      ! The function f is passed as an argument:
!      INTERFACE
!         subroutine f(x,y,y_prime,n_unknowns)
!            USE Precision
!            INTEGER n_points
!            REAL(KIND=wp) :: x
!            REAL(KIND=wp), DIMENSION(n_unknowns) :: y, y_prime
!         end subroutine f
!      END INTERFACE
!      integer :: n_unknowns,n_points
!      integer :: i
!      ! Upon exit, this array should contain the solution
!      real(kind=wp), dimension(n_unknowns,n_points) :: y
!      real(kind=wp) :: dx, x0 ! Step size and initial x
!      real(kind=wp), dimension(n_unknowns) :: y0 ! Initial y
!
!!      ...
!!      ...Declare any needed local variables here...
!!      ...Initialize variables for the DO loop...       
!      DO i=1,n_points-1
!!         ...Calculate x here in steps of dx starting at x0...
!         CALL f(x,y(:,i),y_prime,n_unknowns)
!         y(:,i+1)=y(:,i)+y_prime*dx ! Euler's method
!!         ...
!      END DO
!!      ...
!   end subroutine Euler
!END MODULE IVPSolve

!Another one------

! =================================================================================================
! E.O.F.