!
!  File is Modules.f90
!
!  Fhis file contains the global modules and defined types for WaterSim
!
! OUTPUTS:
!
! created on 09.30.09
!
! david arthur sampson
! last write was: 02.10.12
! -------------------------
!
! =================================================================================================
Module gm_GlobalData
   logical :: lexist
   integer :: LU

   integer :: gv_exceptionCode=0
   logical :: gvl_mask(35)
   ! used for defining array bounds
   integer, parameter :: gpi_lBY=2000
   integer, parameter :: gpi_uBY=2085
   ! Used for array declarations
   integer, parameter :: gvi_maxProV=35
    ! Used to conduct "do" loops, etc.
   integer, parameter :: gvi_Providers=35
   !
   ! Used for indexing (and assigning) arrays
   integer, parameter :: gpi_minPVY=2000
   integer, parameter :: gpi_maxPVY=2085
   ! Used in the Include file
   integer, parameter :: gpi_maxCOrec=1250
   integer, parameter :: gpi_maxSVTrec=700

   integer, parameter :: gpi_dailySVTrec=24471
   integer, parameter :: gpi_dailySVT=24471 !9150 was 366*25 years
 
   ! Constants
   real,parameter     :: gpf_daysMonth=30.416666667
   real,parameter     :: gpf_gallonsToliters=3.785411784
   real, parameter    :: gpf_sqftInOnesqm=10.763910417
   real,parameter     :: gpf_sqftInAcre=43560
   real(8), parameter :: gpd_acftTomaf=1e-6
   real(8), parameter :: gpd_galperacft=325851.43326
   real(8), parameter :: gpd_ft3sToacftmonth=60.33057764466317
   real(8), parameter :: gpd_m3Toacft=0.00081071318212
   real(8), parameter :: gpd_acftToft3=43560.000627
    !
   integer, parameter :: gpi_timeStep=1
   integer, parameter :: gpi_timeStepWB=1
   !
   ! Default Time lag (in years) for vadose to aquifer
   integer, parameter :: gpi_Tlag=10
  ! --------------------------------------------------------
   logical, parameter :: gpl_DemandDriven=.true.
   logical, parameter :: gpl_ClimateDriven=.false.
   logical, parameter :: gpl_SVT_SESDriven=.false. ! use simple exponential smoothing to reduce Climate factor on SVT 
    !
   integer, parameter :: gpi_start=2000
   integer, parameter :: gpi_end=2085
  !
  ! These are Important
   logical            :: gpl_validate=.false.
   logical, parameter :: gpl_release=.true.
   logical            :: gvl_WriteToDisk=.false.
   logical, parameter :: gpl_test_SRPrelease=.false.
   logical, parameter :: gpl_test=.true.
    !
    ! GAP counter balance
   logical :: gpl_holdGD_one
  !
End Module gm_GlobalData
!
Module gm_GlobalFiles
    integer, parameter :: gfi_hold=0
End Module gm_GlobalFiles
Module gm_VersionControl
  ! These are testing version control for dll labeling
  !integer :: num
  integer, parameter :: gdi_Month=04
  integer, parameter :: gdi_Day=10
  integer, parameter :: gdi_Hour=8
  integer, parameter :: gdi_Min=25
End Module gm_VersionControl
!
Module gm_providerDef

End Module gm_providerDef
!
Module gm_GlobalParms
 use gm_GlobalData
   ! CitiModel.f90
   real :: gdf_parm_minGWtoGWT(gvi_maxProV),gdf_parm_maxGWtoGWT(gvi_maxProV)
   real :: gvf_holdGD,gvf_holdGD2
End Module gm_GlobalParms
!
Module gm_Exception
 use gm_GlobalData
  ! Exception to tract run-time errors (use in subroutines or functions)
  type Exception
   integer :: Prov,gvi_hold,gvi_hold2
   integer :: TStep
   !
   character(8) :: MySub
   character(10) :: MyFunction
   character(20) :: Mycall
  end type Exception
End Module gm_Exception
!
Module gm_ModelControl
 use gm_GlobalData
    ! Simulation Controls
    type runTime
     integer :: year=0,month=0,simyear=0        ! simyear is 0 to N (year number in simulation stream)
     integer startyear,endyear
     integer simulations                        ! Number of years to simulate (i.e. 25)
     integer :: days,gvi_holdrun
    end type

End Module gm_ModelControl
!
Module gm_TypeControl
  use gm_GlobalData
   ! Type constructs used throughout the model
   type RiverA
    real(8) :: aRelease,aFlow,aFlowRaw,aAcfta
    real(8) :: gvd_ClassAarray_10_maf(10),aPreReleaseExcess
    real(8) :: gvd_ExpectedStorage_A_maf(gpi_lBY:gpi_uBY),gvd_PreReleaseExcess_A_maf(gpi_lBY:gpi_uBY)
    real(8) :: gvd_releaseExcess_A_maf_yr(gpi_lBY:gpi_uBY),gvd_SRP_release_maf_yr(gpi_lBY:gpi_uBY)

    !
    real :: gvf_storageAlloted_35_AF(gvi_maxProV),gvf_BCstorageUseMax_AF
    real :: gvf_classBCmax(10),gvf_classBCfromReservoir(gvi_maxProV)
    real :: gvf_pumpingSRP_35_AF(gvi_maxProV),gvf_SRPdemandDifference_10_AF(10)
    !
    real :: gvf_SRP_NCSmaxAllocations(10),gvf_classBCavailableTopump(gvi_maxProV)
    real :: gvf_SRP_classA_AF_35(gvi_maxProV),gvf_SRP_NCS_AF_35(gvi_maxProV)
    real :: gvf_Unused_Class_A_AF(gvi_maxProV)
    real :: gvf_pumpingSRP_maf,gvf_releaseSRP_maf
   end type RiverA
   type RiverB
     real(8) :: bFlow,bFlowRaw,bCAPmaricopa,bCAP_maf
   end type RiverB
   type Surfacewater
     real(8) :: sAcftPerAcre,sCAPmaricopa_maf,sCAP_maf,sSVTflow_maf
     real(8) :: sSVTPreRelease_maf,sSRPrelease_maf,sMaricopaSWS_maf,lvd_hold
     real :: sNCSmaxAllocations_maf(10),gvf_holdSW1
     real :: lvf_unusedClass_A_AF(gvi_maxProV),gvf_pumpBandC_35_AF(gvi_maxProV)
    End type Surfacewater
!
    type Provider
     !
     real(8) :: gAclassAdesignations_A_maf(gpi_lBY:gpi_uBY,10)
     real(8) :: gAclassBCdesignationsMax_10_maf(gpi_lBY:gpi_uBY,10)
     real(8) :: gAclassBCdesignationsUsed_A_maf(gpi_lBY:gpi_uBY,10)

     real(8) :: gArealizeddesignations_A_maf(gpi_lBY:gpi_uBY,10)

     real    :: gApumpingSRP_maf(gpi_lBY:gpi_uBY,10)
     real    :: gAclassAmax_A_maf(gpi_lBY:gpi_uBY,10)
     real    :: gRealizedDesignationCAP_acft(gpi_lBY:gpi_uBY,gvi_maxProV)
     ! 12.14.11 DAS
!     real    :: gAddedDesignationCAP_acft(gpi_lBY:gpi_uBY,gvi_maxProV)

     real    :: gCAPMandI_II(gpi_lBY:gpi_uBY)
     !
     real(8) :: oGWpumpingNoSRP_a_maf(gvi_maxProV),oGWrecharge_a_maf(gvi_maxProV)
     real(8) :: oSWandSRPused_a_maf(gvi_maxProV),oSRPpumping_a(gvi_maxProV)
     real(8) :: oDemandNoAg_acft(gvi_maxProV)
     !
     ! generic- used by CitiWaterBudgets.f90- 
     ! -----------------------------------------------------------------------
     real :: gvf_cCAP_used_AF_a(gvi_maxProV)
     real :: gvf_cSRP_A_used_AF_a(gvi_maxProV)
     real :: gvf_cSRP_BC_used_AF_a(gvi_maxProV)
     real :: gvf_cSRP_NCS_used_AF_a(gvi_maxProV)
     real :: gvf_cSRP_BCresAndPump_AF_a(gvi_maxProV)
     !
 
     ! The annual amount sent to the WB- created in sBanking_s() in Kernel.f90
     real :: gvf_cSetWBanking_a(gvi_maxProV),gvf_cGetWBanking_a(gvi_maxProV)
     ! The annual amount sent to the Vadose and DI as set by sVadoseAndDI_s() in Kernel.f90
     real :: gvf_cVadose_a(gvi_maxProV),gvf_cDirectInjection_a(gvi_maxProV)

     ! Monthly time-step : demand -----------------------------
     real :: lvf_cDemand_Res_outdoor_Af_monthly(gvi_maxProV,12)
     real :: lvf_cDemand_Res_indoor_Af_monthly(gvi_maxProV,12)
     real :: lvf_cDemand_Cio_outdoor_Af_monthly(gvi_maxProV,12)
     real :: lvf_cDemand_Cio_indoor_Af_monthly(gvi_maxProV,12)
     !
     ! annual time-step ---------------------------------------
     real :: lvf_cDemand_Res_outdoor_AF_annual(gvi_maxProV)
     real :: lvf_cDemand_Res_indoor_AF_annual(gvi_maxProV)
     !
     real :: lvf_cDemand_Cio_outdoor_AF_annual(gvi_maxProV)
     real :: lvf_cDemand_Cio_indoor_AF_annual(gvi_maxProV)
     !
     real :: gvf_cCAP_acft(gvi_maxProV)
     real :: gvf_cMunicipalPumping_AF(gvi_maxProV)
     real :: gvf_cSRPclassBC_AF_monthly(gvi_maxProV,12),gvf_cSRPNCS_AF_monthly(gvi_maxProV,12)
     real :: gvf_pMunicipalPumping_acft_monthly(gvi_maxProV,12)
 
     real :: gvf_pAddToSRPrelease(gvi_maxProV)
     !
     real :: cPopProvider(gvi_maxProV)
     ! 
    end type Provider
 !
    type Energy
     real :: gv_eCAP_used_GWhMcum(2,12)
     real :: gv_eCMout(gvi_maxProV,12)
     real :: gv_eSWtoWTP(gvi_maxProV,12),gv_eWTPtoWS(gvi_maxProV,12),gv_eGWtoWTP(gvi_maxProV,12),gv_eGWtoAg(gvi_maxProV,12)
    end type Energy
    !
    type EnergyWB
     real :: gv_wSWtoWTP(gvi_maxProV,12),gv_wWTPtoWS(gvi_maxProV,12)
     real :: gv_wGWtoWTP(gvi_maxProV,12),gv_wGWtoAg(gvi_maxProV,12)
     real :: gv_wEffluenttoPower(gvi_maxProV,12)
     real :: gv_wSRPtoE(12)
    end type EnergyWB
    !
    type Demand
     real(8) :: dag_demand(gpi_lBY:gpi_uBY), dres_demand(gpi_lBY:gpi_uBY),dcio_demand(gpi_lBY:gpi_uBY)
     real(8) :: dpopGrowthFactor
    end type Demand
    !
    type SalinityWB
      real :: gvf_sCAPtoTDS_acft(gvi_maxProV,12),gvf_sSRPclassAtoTDS_acft(gvi_maxProV,12)
      real :: gvf_sFluxSWTPtoWS_SW_acft(gvi_maxProV,12)
      real :: gvf_sFluxWWresToWWTP_acft(gvi_maxProV,12),gvf_sFluxWWcioToWWTP_acft(gvi_maxProV,12)
      real :: gvf_sFluxWWwwtpToRWWTP_acft(gvi_maxProV,12),gvf_sFluxWWtwtpToAg_acft(gvi_maxProV,12)
      real :: gvf_sSRPNCStoTDS_acft(gvi_maxProV,12),gvf_sSRPclassBCtoTDS_acft(gvi_maxProV,12)
      real :: gvf_sSRPclassBCstorage_acft(gvi_maxProV,gpi_timeStepWB)
      !
      real :: gvf_sFluxGWaterBanking(gvi_maxProV,12)
      real :: gvf_sMuniPumpingtoTDS_acft(gvi_maxProV,12), gvf_sMuniPumpingTreatedtoTDS_acft(gvi_maxProV,12)
      real :: gvf_sReclaimed_acft(gvi_maxProV,12), gvf_sROreclaimed_acft(gvi_maxProV,12)
      !
      real :: gvf_sFluxRes_acft(gvi_maxProV,12),gvf_sFluxResIndoor_acft(gvi_maxProV,12)
      real :: gvf_sFluxResOutdoor_acft(gvi_maxProV,12)
      real :: gvf_sFluxCio_acft(gvi_maxProV,12),gvf_sFluxCioIndoor_acft(gvi_maxProV,12)
      real :: gvf_sFluxCioOutdoor_acft(gvi_maxProV,12)
      real :: gvf_sFluxRunoffPerc_acft(gvi_maxProV,12)
      real :: gvf_sGwaterToAgToTDS_acft(gvi_maxProV,12)
      real :: gvf_sMuniRechargeToTDS_acft(gvi_maxProV,12)
    end type SalinityWB
    !
 End Module gm_TypeControl
!
Module gm_Global
      ! 
      type SVTonto_p
       sequence
        real :: f_classA_maf_yr,f_classA_af_mo(12)
        real :: f_classBC_maf_yr,f_classBC_af_mo(12)
        real :: f_NCS_af_yr,f_NCS_af_mo(12)
        real :: f_gwpumping_af_yr,f_gwpumping_af_mo(12)
      end type SVTonto_p
      type SVTonto_r
       sequence
        integer :: gvi_state
        integer :: gvi_release
        integer :: gvi_runoff
      end type SVTonto_r
      ! River operations
      type(SVTonto_r) :: SVT_ro

      type COLO_r
       sequence
        integer :: state
        integer :: release
        integer :: runoff
      end type COLO_r
      type(COLO_r) :: CO_ro

      type COLO_p
       sequence
        integer :: designations
      end type COLO_p
      ! Provider operations
     type Operations
      sequence
       integer :: N 
       type(SVTonto_p) :: SVT_po
       type(COLO_p) :: CO_po
     end type operations

    type providers
        sequence
        integer :: num
        type(Operations) :: ad
        type(Operations) :: wt 
        type(Operations) :: pv 
        type(Operations) :: su 
        type(Operations) :: sw 
        type(Operations) :: av 
        type(Operations) :: be 
        type(Operations) :: bu 
        type(Operations) :: cf 
        type(Operations) :: cc 
        type(Operations) :: ch 
        type(Operations) :: cp 
        type(Operations) :: sp 
        type(Operations) :: cu 
        type(Operations) :: dh 
        type(Operations) :: em 
        type(Operations) :: gi 
        type(Operations) :: gl 
        type(Operations) :: go 
        type(Operations) :: lp 
        type(Operations) :: me 
        type(Operations) :: no 
        type(Operations) :: op 
        type(Operations) :: pe 
        type(Operations) :: ph 
        type(Operations) :: qk 
        type(Operations) :: rg 
        type(Operations) :: rv 
        type(Operations) :: ry 
        type(Operations) :: sc 
        type(Operations) :: sr
        type(Operations) :: te 
        type(Operations) :: to 
        type(Operations) :: vu 
        type(Operations) :: we 
    end type providers
    !
    interface assignment (=)
      module procedure arrayToVector_ncs_mo
    end interface
  contains
      subroutine arrayToVector_ncs_mo(vec_result,array_f)
        type(providers), intent(out) :: vec_result
        real, dimension(12), intent(in) :: array_f
        !
        vec_result%av%SVT_po%f_NCS_af_mo(1)=array_f(1)
        vec_result%av%SVT_po%f_NCS_af_mo(2)= array_f(2)
        vec_result%av%SVT_po%f_NCS_af_mo(3)= array_f(3)
        vec_result%av%SVT_po%f_NCS_af_mo(4)= array_f(4)
        vec_result%av%SVT_po%f_NCS_af_mo(5)= array_f(5)
        vec_result%av%SVT_po%f_NCS_af_mo(6)= array_f(6)
        vec_result%av%SVT_po%f_NCS_af_mo(7)= array_f(7)
        vec_result%av%SVT_po%f_NCS_af_mo(8)= array_f(8)
        vec_result%av%SVT_po%f_NCS_af_mo(9)= array_f(9)
        vec_result%av%SVT_po%f_NCS_af_mo(10)= array_f(10)
        vec_result%av%SVT_po%f_NCS_af_mo(11)= array_f(11)
        vec_result%av%SVT_po%f_NCS_af_mo(12)= array_f(12)
        !
     end subroutine arrayToVector_ncs_mo
 
End Module gm_Global
!
! =================================================================================================
! E.O.F.