!   
!  File is WaterShed_CO.f90
!
! This file simulates the Colorado River System
!
! Global OUTPUTS:
!              
!              
!               
!              
!
! Local OUTPUTS:
!            
!             
!   
! Local INPUTS:
!              
!              
!---------------------------------------------------
! created on 10.01.09
!
! david arthur sampson
! last write was: 03.27.12
! -------------------------------------------------------------------------------------------------
!
!
! =================================================================================================
Module lm_River_ba
 use gm_ModelControl
  use gm_GlobalData
    use gm_Euler
   !
    include "C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt"
    !
 contains
      subroutine initWSB()
       call openFiles_b()
       call readParms_b()
       call readFiles_b()
       call initialState_b()
      end subroutine initWSB
      ! --------------------

        ! ----------------------
        subroutine openFiles_b()
         !
         character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
          if(gpl_release)lvc_dataPath=trim(gvc_DPath)
            !
         inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\BofR_CObase.txt'),exist=lexist)
           LU=10
           if(lexist)then
            open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\BofR_CObase.txt'),status='old')
           else
            goto 10
           endif
            !
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\CORiver_BofR.txt'),exist=lexist)
          LU=11
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\CORiver_BofR.txt'),status='unknown')
          else
           goto 10
          endif
            !
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\CORiver_paleo.txt'),exist=lexist)
          LU=12
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\CORiver_paleo.txt'),status='unknown')
          else
           goto 10
          endif
            !
           inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\CORiver_scenario.txt'),exist=lexist)
           LU=13
           if(lexist)then
            open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\CORiver_scenario.txt'),status='unknown')
           else
            goto 10
           endif
            !
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\powellequalizations.txt'),exist=lexist)
          LU=22
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\powellequalizations.txt'),status='unknown')
          else
           goto 10
          endif
            !
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\Initial_storage.txt'),exist=lexist)
          LU=23
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\Initial_storage.txt'),status='unknown')
          else
           goto 10
          endif
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_CO.dat'),exist=lexist)
          LU=30
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_CO.dat'),status='unknown')
          else
           goto 10
          endif
         !
            LU=0
10        continue
            gv_exceptionCode=LU
            if(LU .ne. 0)then
             if(gvl_WriteToDisk)then
              write(*,*)"Data for the Colorado River are missing; logical unit is= ", LU
              write(7,*)"CO error on reading input"
              write(7,*)" Units are: ",LU
              write(7,*)" "
              write(7,*)"open(10,FILE='App_Data\Data\co_monthly.txt',status='old')"
              write(7,*)"open(11,FILE='App_Data\Data\CORiver_BofR.txt',status=old)"
              write(7,*)"open(22,FILE='App_Data\Data\powellequalizations.txt',status='unknown')"
              write(7,*)"open(23,FILE='App_Data\Data\Initial_storage.txt',status='unknown')"
              write(7,*)"open(30,FILE='App_Data\Parameters\parm_CO.dat',status='old')"
             endif
            endif
          return
        end subroutine openFiles_b
       ! -------------------------

        ! ----------------------
        subroutine readFiles_b()
            !
            integer :: i,j
            integer :: rec,ios
            real :: A(2000:2010),temp
            ! ----------------------
            !
            ios=0
            rec=0
            LU=0
            ! Read Unit 10; Colorado River base data 2000 to 2010 data
            !-----------------------------------------------------
            !
            LU=10
            do rec=1,11,1
              read(LU,*,err=1)temp,lvd_iflowCObase_AF(rec)
              temp=temp
            end do
             close(LU)
            ! 
            !-----------------------------------------------------
            !
            do i =1,1250,1
              do j = 1,3,1
                li_iflowCOacft(j,i)=0
              end do
            end do

            LU=11
             do rec=1,102,1
              read(LU,*,err=1)li_iyearCO(1,rec),li_iflowCOacft(1,rec)
             end do
             close(LU)
             lv_recordCO(1)=(gv_indexyearCO-li_iyearCO(1,1)) 

            ! Paleo
            !  1st record is nominally 762 AD
            LU=12
             do rec=1,1244,1
              read(LU,*,err=1)li_iyearCO(2,rec),li_iflowCOacft(2,rec)
             end do
             close(LU)
             lv_recordCO(2)=(gv_indexyearCO-li_iyearCO(2,1)) 

             LU=13
             do rec=1,75,1
              read(LU,*,err=1)li_iyearCO(3,rec),li_iflowCOacft(3,rec)
                li_iflowCOacftScenario(rec)=li_iflowCOacft(3,rec)
             end do
             close(LU)
             lv_recordCO(3)=1 
            !
1           continue
            if(ios >0)then
            
            goto 1000
            endif
            !
            !---------------------------------------------------------------------------
            !
            ! ft3 s-1 on a monthly basis
            ! USGS monthly data from lee's Ferry, AZ
            !http://waterdata.usgs.gov/nwis/monthly?referred_module &
            ! =sw&amp;site_no=09380000&amp;por_09380000_1=19133,00060,&
            ! 1,1921-10,2009-06&amp;start_dt=1922-01&amp;end_dt=2009-01 &
            ! &amp;format=html_table&amp;date_format=YYYY-MM-DD&amp; &
            ! rdb_compression=value&amp;submitted_form=parameter_selection_list
            ! ----------------------------------------------------------
            !---------------------------------------------------------------------------
            !

            ! Read unit 15; powell equalizatoins
            !--------------------------------------------------------------------------
            !
            LU=22
            read(LU,*,err=6,iostat=ios)((li_powellequal(i,j),j=1,3),i=2000,2037)
6           continue
            close(15)
            if(ios >0)then
             LU=22
            goto 1000
            endif
            ! http://lakepowell.water-data.com/index2.php
            ! http://lakemead.water-data.com/index2.php
            LU=23
            do i = 2000,2010,1
             read(LU,*,err=7,iostat=ios)iyear,A(i),li_initstoragePowell(i),li_initstorageMead(i)
              A(i)=A(i)*1 ! Only used to stop verbose warnings
              iyear=iyear
            end do
             lv_firstYear_b=2000
7           continue
            close(23)
            if(ios >0)then
            LU=23
            goto 1000
            endif

         return
         1000 continue
           if(gvl_WriteToDisk)&
            write(7,*)" Error reading file input:WaterShed_CO.f90-Line 236: logical unit is:", LU
        end subroutine readFiles_b
        ! -----------------------

        ! ----------------------
        subroutine readParms_b()
            !
            read(30,*)li_capcapacity
            read(30,*)li_capevapconst
            read(30,*)li_capmaricopashare
            read(30,*)gv_climatefactorCO
            read(30,*)gv_droughtfactorCO
            read(30,*)gv_droughtyearCO
            read(30,*)gv_indexyearCO 
            read(30,*)li_meaddeadpool
            read(30,*)li_meadmax
            read(30,*)li_numdroughtyearsCO
            read(30,*)li_powelldeadpool
            read(30,*)li_powellmax
            read(30,*)li_yumaallocation
            !
            close(30)
            gv_droughtyearendCO=gv_droughtyearCO+li_numdroughtyearsCO
            !
           return
        end subroutine readParms_b
        ! ------------------------

        ! -------------------------
        subroutine initialState_b()
            ! 
            go_riverFlowCO=li_iflowCOacft(gv_dataCO,lv_recordCO(1))
            vState_Ba_maf(2006)=li_initstoragePowell(2006)*li_powellmax
            vState_Bb_maf(2006)=li_initstorageMead(2006)*li_meadmax
             vState_Ba_maf(2001)=li_initstoragePowell(2001)*li_powellmax
             vState_Bb_maf(2001)=li_initstorageMead(2001)*li_meadmax

            go_StateCO=nint(vState_Ba_maf(2006)+vState_Bb_maf(2006))*1e6
            go_deliveriesCO=nint(1.5*1e6)
            ! ~
        end subroutine initialState_b 
        ! ---------------------------
End Module lm_River_Ba
!
Module lms_River_Ba
 use gm_ModelControl
  use gm_GlobalData
   use gm_TypeControl
    use gm_Euler

    implicit none
   ! -------------
!    logical, private :: lvl_validate=.false.
    ! -------------------------------------
    ! sent as output to the interface
    ! ---------------
    !    integer, public  :: go_riverFlowCO
    !    integer, public  :: go_StateCO
    !    integer, public  :: go_StatePowell
    !    integer, public  :: go_StateMead
    ! -------------------------------------
      !
      include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
      !
      real, private :: lvf_initial_state_Powell,lvf_initial_state_Mead
      !
      type watershed_B
        real(8):: vState_Ba_pred_maf(gpi_lBY:gpi_uBY)
        real(8):: vState_Bb_pred_maf(gpi_lBY:gpi_uBY)
        real(8) :: lv_flowAdjustToMead(gpi_lBY:gpi_uBY)
        real(8):: lv_BaToBb(gpi_lBY:gpi_uBY),lv_OverFlow_ba(gpi_lBY:gpi_uBY)
        real(8):: lv_BaToBb_monthly(gpi_lBY:gpi_uBY,12)
        real(8):: lv_AZshareCO
        real(8) :: lv_CAPmaricopa(gpi_lBY:gpi_uBY)
        real(8) :: lv_CAP(gpi_lBY:gpi_uBY),lv_AZshortageCO,lvd_upperBasin,lvd_3
      end type watershed_B
      ! 
   contains
    ! =============================================================================================

      ! -----------------------
      subroutine aFlow_b(T,acft)
        !
        logical :: lvl_noTrace=.false.
        logical :: lvl_start2000
        integer :: acft
        integer :: i,j,lvi_totalyears
        integer :: lvi_addRecords
        integer :: lvi_addRec

        type(runTime)T
       ! ===============
        !
        lvl_start2000=.true.
        lvi_addRec=0
        lvi_addRecords=0  
        if(gv_dataCO < 1)gv_dataCO=1
        !
        if(acft > 0)then
         ! For testing purposes (i.e., Testing.f90)
         lv_flow_B_maf(T%year)=acft*gpd_acftTomaf
        else
         !   Actual simulations: gpi_timeStep = 1, use annual data, otherwise, sum the monthly data
         ! (so that annual and monthly simulations are using the same input data (for runoff)
         !
         if(T%year == T%startyear)then
          !
          do i = 1,200,1
            do j = 1,3,1
             lvi_flowCOacftMod(j,i)=0
            end do
          end do
            !
            vArecB=1208           
            vArecB=(gv_indexyearCO-li_iyearCO(gv_dataCO,1))
            !
            lvi_totalyears=T%endyear-T%startyear  +1
            !
            lvl_noTrace=.false.
          if(gv_dataCO == 1)then
          else if(gv_dataCO == 2)then
          else if(gv_dataCO == 3)then
            lvl_noTrace=.true.
          endif
            !
                if(gvi_COtrace < 1)gvi_COtrace=25
                !
              if(lvl_noTrace)then
               !
               do i = 1,11,1
                 lvi_flowCOacftMod(gv_dataCO,i)=lvd_iflowCObase_AF(i)
               end do !li_iflowCOacft(3,rec)
                do j = 12,86,1
                 lvi_flowCOacftMod(gv_dataCO,j)=li_iflowCOacftScenario(j-11) 
               end do
                !
                vArecB=0 
                !
              else
                ! 
                if(lvl_start2000)then
                  ! Actually start in 2001
                  do i = 1,11,1
                    lvi_flowCOacftMod(gv_dataCO,i)=lvd_iflowCObase_AF(i)
                  end do
                    !
                     do i = 12,lvi_totalyears,1
                          lvi_flowCOacftMod(gv_dataCO,i)=li_iflowCOacft(gv_dataCO,vArecB+1+lvi_addRecords)
                          lvi_addRecords=lvi_addRecords+1
                        if(vArecB+lvi_addRecords >vArecB+gvi_COtrace)then
                          lvi_addRecords=0
                          lvi_flowCOacftMod(gv_dataCO,i)=li_iflowCOacft(gv_dataCO,vArecB+1+lvi_addRecords)
                          lvi_addRecords=lvi_addRecords+1

                        endif
                      end do
                    !
                  vArecB=0 + lvi_addRec
                else
                     do i = 1,lvi_totalyears,1
                          lvi_flowCOacftMod(gv_dataCO,i)=li_iflowCOacft(gv_dataCO,vArecB+1+lvi_addRecords)
                          lvi_addRecords=lvi_addRecords+1
                        if(vArecB+lvi_addRecords >vArecB+gvi_COtrace)then
                          lvi_addRecords=0
                          lvi_flowCOacftMod(gv_dataCO,i)=li_iflowCOacft(gv_dataCO,vArecB+1+lvi_addRecords)
                          lvi_addRecords=lvi_addRecords+1
                        endif
                     end do
                  vArecB=0
                endif ! end of start2000
              endif ! of noTrace
           endif ! End of T%startyear
            !
            vArecB=vArecB+1
            !
            ! New Code 06.22.11
            lv_flow_B_maf(T%year)=lvi_flowCOacftMOD(gv_dataCO,vArecB)*gpd_acftTomaf !/1e6
            !
            if(lvl_noTrace)then
            else
              if(2000 < T%year)then
                if(1 < vArecB)then
                    lv_flow_B_maf(T%year-1)=lvi_flowCOacftMOD(gv_dataCO,vArecB-1)*gpd_acftTomaf
                else
                    lv_flow_B_maf(T%year-1)=lvi_flowCOacftMOD(gv_dataCO,vArecB)*gpd_acftTomaf
                endif
              else
                if(1 < vArecB)then
                    lv_flow_B_maf(T%year)=lvi_flowCOacftMOD(gv_dataCO,vArecB-1)*gpd_acftTomaf
                else
                    lv_flow_B_maf(T%year)=lvi_flowCOacftMOD(gv_dataCO,vArecB)*gpd_acftTomaf
                endif
              endif
            endif
            lv_flow_B_maf(T%year+1)=lvi_flowCOacftMOD(gv_dataCO,vArecB+1)*gpd_acftTomaf
            !
            if( lv_flow_B_maf(T%year) <=0)then
            ! catch this exception
            lv_flow_B_maf(T%year)=0.
            goto 100
           endif

        endif
        !
        return
100     continue
         if(gvl_WriteToDisk)&
          write(7,*)" Flow for the CO is zero or less than zero- line 454-WaterShed_CO.f90"

      end subroutine aFlow_b
      !---------------------

      ! --------------------------
      subroutine aModifyFlow_ba(T)
        !
        type(runTime)T
        ! ===============
        ! An artifact of having the correct release, yet 
        ! the storage in Powell is off.
        ! 04.03.12
        ! --------------------------------------------------
        if(T%year == 2001)then
          lv_flow_B_maf(T%year)=lv_flow_B_maf(T%year)*1.025
        else if(T%year == 2002)then
          lv_flow_B_maf(T%year)=lv_flow_B_maf(T%year)*1.1
        else if(T%year == 2008)then
          lv_flow_B_maf(T%year)=lv_flow_B_maf(T%year)*1.3
        else if(T%year == 2009)then
          lv_flow_B_maf(T%year)=lv_flow_B_maf(T%year)*1.33
        else if(T%year == 2010)then
          lv_flow_B_maf(T%year)=lv_flow_B_maf(T%year)*1.3      
        endif
        ! --------------------------------------------------
         !
         lv_flow_B_maf(T%year)=lv_flow_B_maf(T%year)*gv_climatefactorCO
         !
        if(T%year >= gv_droughtyearCO)then
         if(T%year <=  gv_droughtyearendCO)then
          lv_flow_B_maf(T%year)=lv_flow_B_maf(T%year)*gv_droughtfactorCO
         endif
        endif
        !
        ! Send to the interface
        go_riverFlowCO=NINT(lv_flow_B_maf(T%year)* (1./gpd_acftTomaf))
        !
        return
      end subroutine aModifyFlow_ba
      !----------------------------

      ! ------------------------------
      subroutine aModifyFlow_bb(T,wsb)
        !
        real(8) :: vToMead = 0.02 ! 0.12 Tim's variable
        type(watershed_B)::wsb
        type(runTime)T
        ! =============
        !
        ! This is code left over from Tim Lant's work.  I do not
        ! fully understand what he was doing, and have only modified
        ! it slightly in the parameterization schema; I reduced the
        ! diversion amount to 2%
        ! ========================================================== 

        wsb%lv_flowAdjustToMead(T%year)=lv_flow_B_maf(T%year)*vToMead
        lv_flow_B_maf(T%year)=lv_flow_B_maf(T%year)-wsb%lv_flowAdjustToMead(T%year)
        !
        return
      end subroutine aModifyFlow_bb
      !---------------------------

      ! --------------------------
      subroutine aModifyFlow_bc(T,wsb)
        !
        real(8) :: lv_first=5.5
        real(8) :: lv_second=4.45
        real(8) :: lv_third

        real(8) :: lv_upperBasin  ! maf
        real(8) :: vMax
        !
        type(watershed_B)::wsb
        type(runTime)T
        ! ===============
        ! 
        ! This too is code left over from Tim Lant's work.  I do not
        ! fully understand what he was doing, and have only modified
        ! it slightly in the parameterization schema.
        ! Summed flows are less than the upper basin amount of 7.45 maf
        ! ========================================================== 
        lv_third=(0.98/55.) * T%simyear
        lv_upperBasin=min(lv_first,lv_second+lv_third) 
        !
        vMax=lv_flow_B_maf(T%year)-(lv_UpperBasin*0.79) 
        wsb%lvd_upperBasin=lv_UpperBasin*0.79
        lv_flow_B_maf(T%year)=max(0.,vMax)
        !
        return
      end subroutine aModifyFlow_bc
      !----------------------------

      ! ----------------------------
      subroutine reservoirs_b(T,wsb)
       !
        type(watershed_B)::wsb
        type(runTime)T
        ! ============
        !
        call initialStorage_B(T)            ! initial storage powell and mead
        call expectedStorage_ba(T,wsb)      ! initialize powell: pre-powell
        call expectedStorage_bb(T,wsb)      ! initialize Mead

        call aModifyStorage_ba(T,wsb)       ! Powell equalizations - seven states rules
        call aModifyStorage_bb(T,wsb)       ! lower basin water demand/use
        call designations_B(T,wsb)          ! CAP allocations
        !
        return
      end subroutine reservoirs_b
      !--------------------------

      ! ----------------------------------
      subroutine expectedStorage_ba(T,wsb)
            !
            real(8) :: lv_Evap_ba
            real(8) :: fEvaporation_b
            real :: lvf_flux
            real :: lvf_normalRelease=8.23
            type(watershed_B)::wsb
            type(runTime)T
            ! ============
             !
             ! Re-analyzed on 04.02.12 (maf)
             ! --------------------------------------------------------------------
              lv_Evap_ba=0.
             lv_Evap_ba=fEvaporation_b(vState_Ba_maf(T%year))  
             !
             lvf_flux=0
            lvf_flux=(max(0.,vState_Ba_maf(T%year)+lv_flow_B_maf(T%year) &
                -lvf_normalRelease-wsb%lv_flowAdjustToMead(T%year))) 
            !
            if(li_powelldeadpool < lvf_flux)then
             wsb%vState_Ba_pred_maf(T%year)= lvf_flux
              if(li_powellmax < lvf_flux)wsb%vState_Ba_pred_maf(T%year)= li_powellmax
            else
             wsb%vState_Ba_pred_maf(T%year)=li_powelldeadpool
            endif
             !
            return
        end subroutine expectedStorage_ba
        !--------------------------------

        ! ----------------------------
        subroutine initialStorage_B(T)

            type(runTime)T
            ! ===============
             ! Total Volume and NOT live volume (maf)
             ! --------------------------------
             if(T%year == T%startyear)then
                vState_Ba_maf(T%year)=li_initstoragePowell(T%year)*li_powellmax !+ li_powelldeadpool
                 lvf_initial_state_Powell=vState_Ba_maf(T%year)
                vState_Bb_maf(T%year)=li_initstorageMead(T%year)*li_meadmax !+ li_meaddeadpool
                 lvf_initial_state_Mead= vState_Bb_maf(T%year)
             endif
             !
        end subroutine initialStorage_B
        !------------------------------

        ! ---------------------------------
        subroutine expectedStorage_bb(T,wsb)

            real(8) :: lv_Evap_bb,fEvaporation_b
            real :: lvf_flux
            real, parameter :: lvp_normalOut=9.
            real,parameter :: lvp_normalIn=8.23
            type(watershed_B)::wsb
            type(runTime)T
            ! ===============
             !
             ! Total volume and NOT live volume
             ! ------------------------------------------------------------------------
              lv_Evap_bb=0.
             lv_Evap_bb=fEvaporation_b(vState_Bb_maf(T%year))  
             !
             lvf_flux=0
            lvf_flux=max(0.,vState_Bb_maf(T%year)+lvp_normalIn-lvp_normalOut-lv_Evap_bb)
            !
            if(li_meaddeadpool < lvf_flux)then
             wsb%vState_Bb_pred_maf(T%year)= lvf_flux 
            else
             wsb%vState_Bb_pred_maf(T%year)=li_meaddeadpool
            endif
             !
        end subroutine expectedStorage_Bb
        !--------------------------------

        ! ---------------------------------
        subroutine aModifyStorage_ba(T,wsb)

            logical :: lvl_RecordOfDecision
            integer :: vTier
            real(8) :: lv_Evap_ba,fEvaporation_b
            real(8) :: lv_State_ba,lvd_Pp,lvd_Pm,lv_balanceamount
            real(8) :: lv_Ssr

            type(watershed_B)::wsb
            type(runTime)T
            ! ============
              !  
              ! lvl_RecordOfDecision = .false. for OLD code prior to 11.16.10 das
            lvl_RecordOfDecision=.true.
             !
             lv_Evap_ba=fEvaporation_b(vState_Ba_maf(T%year))  
             !
             lvd_Pp = wsb%vState_Ba_pred_maf(T%year) 
             lvd_Pm= wsb%vState_Bb_pred_maf(T%year) 
             !
             ! ------------------------------------------------------------------------------------------
              lv_balanceamount=0
             if(lvl_RecordOfDecision)then
                lv_balanceamount=(lvd_Pp-lvd_Pm)*0.5
             endif
              !
!             ! Threshold storage and associated release
              call threshold_b(T,lvd_Pp,lvd_Pm,lv_balanceamount,lv_Ssr,vTier)
              !
                wsb%lv_BaToBb(T%year)=lv_Ssr
                !
                if(gpl_validate)then
                  ! Where did this information come from?
                  wsb%lv_BaToBb(2001)=8.009909 ; wsb%lv_BaToBb(2002)=7.795931
                  wsb%lv_BaToBb(2003)=8.222020 ; wsb%lv_BaToBb(2004)=8.473741
                  wsb%lv_BaToBb(2005)=8.252576 ; wsb%lv_BaToBb(2006)=8.408633
                  wsb%lv_BaToBb(2007)=8.228612 ; wsb%lv_BaToBb(2008)=9.123499
                  wsb%lv_BaToBb(2009)=8.296381 ; wsb%lv_BaToBb(2010)=8.173804
                endif
              !
              lv_State_ba=vState_Ba_maf(T%year)+lv_flow_B_maf(T%year)-wsb%lv_BaToBb(T%year) -lv_Evap_ba
              !
              wsb%lv_OverFlow_ba(T%year)=0
              if(lv_State_ba < li_powellmax)then
                if(lv_State_ba >= li_powelldeadpool)then
                  !
                  vState_Ba_maf(T%year)=lv_State_ba                  !
                  !
                else
                 if(vState_Ba_maf(T%year)-lv_Evap_ba-li_powelldeadpool >= li_powelldeadpool)then
                  wsb%lv_BaToBb(T%year)=vState_Ba_maf(T%year)-lv_Evap_ba-li_powelldeadpool
                  vState_Ba_maf(T%year)=li_powelldeadpool
                  if(gvl_WriteToDisk)&
                   write(7,*)T%year, " Powell Dead Pool - line 665 in WaterShed_CO.f90"
                 else
                  wsb%lv_BaToBb(T%year)=lv_flow_B_maf(T%year)
                  vState_Ba_maf(T%year)=li_powelldeadpool
                  if(gvl_WriteToDisk)&
                   write(7,*)" Powell Dead Pool - line 670 in WaterShed_CO.f90"
                 endif

                endif
              else
                ! 
                vState_Ba_maf(T%year)=li_powellmax
                wsb%lv_OverFlow_ba(T%year)=lv_State_ba-li_powellmax
                !
              endif
            !
          return
        end subroutine aModifyStorage_ba
        ! ---------------------------------

            !--------------------------------------------------------------------------------------
            subroutine threshold_b(T,lvd_Pp,lvd_Pm,lv_balanceamount,lv_Ssr,vTier)
                !
                ! Mead at 1075 feet, volume is 11.801067 maf
                ! Mead at 1025 feet, volume is 8.257580 maf
                !
                ! 04.02.12 DAS
                ! So, I was using the wrong storage numbers.  I was using the live or "active"
                ! but I am modeling the total....
                ! Live storage
                real(8) :: lvd_Pp,lv_balanceamount,lvd_Pm
                real(8) :: lv_Ssr
                integer :: vTier
!                real(8) :: vBa_Teir_1=5.92658 ! Powell at 3,525 feet
!                real(8) :: vBa_Teir_2=9.5173 ! Powell at 3,575 feet
!                real(8) :: vBa_Teir_3=15.5357 ! Powell at 3,636 feet
!                real(8) :: vBa_Teir_4=19.2913 ! Powell at 3,666 feet
                ! 
                ! Total storage
                real(8) :: vBa_Teir_1=7.8216 ! Powell at 3,525 feet
                real(8) :: vBa_Teir_2=11.4123 ! Powell at 3,575 feet
                real(8) :: vBa_Teir_3=17.4307 ! Powell at 3,636 feet
                real(8) :: vBa_Teir_4=21.1863 ! Powell at 3,666 feet

                real(8) :: vTargetRelease_a=8.23
                 ! model elevation = intercept + scaling * storage**slope
                real :: lvf_powell_elevation
                real,parameter :: lvf_totalPowell=27.8659

                type(runTime)T
                ! ===============
                  !
                  ! ====================================================================
                  ! Changed again on 16 November 2010, das
                  !
                  ! Record of Decison, December 2007 (RecordofDecision.pdf)
                  ! page 50-53
                  ! Estimate elevation from storage
                  ! Where is the regression and parameter 95% CI's for this algorithm?
                  ! -------------------------------------------------------------------
                  !
                   lvf_powell_elevation=0
                  if(vState_Ba_maf(T%year) < lvf_totalPowell)then    
                    call elevationsPowell(vState_Ba_maf(T%year),lvf_powell_elevation)
                  endif
                  !
                 if(lvd_Pp < vBa_Teir_1)then
                  vTier=1
                 else
                   if(lvd_Pp < vBa_Teir_2)then
                    vTier=2
                   else
                     if(lvd_Pp < vBa_Teir_3)then
                      vTier=3
                     else
                       if(lvd_Pp <  vBa_Teir_4)then
                         vTier=4
                       else
                         if(lvd_Pp <  li_powellmax)then
                          vTier=5
                         else
                          vTier=6
                         endif
                       endif
                     endif
                   endif
                 endif               
                ! --------------------------------------------
                 if(vTier == 1)then
                    !  new on 03.30.12
                    call balanceContents(lv_balanceamount,vTier,lv_Ssr)
                    !
                 else if(vTier == 2)then 
                    !
                    lv_Ssr=7.48
                    ! Mead at 1025 feet (using total volume NOT live volume)
                    if(lvd_Pm < 7.83602)then
                      lv_Ssr=vTargetRelease_a
                    endif
                    !            
                 else if(vTier == 3)then
                    !
                    lv_Ssr=vTargetRelease_a   
                    !
                    if(lvd_Pm < 11.4049)then
                     call balanceContents(lv_balanceamount,vTier,lv_Ssr)
                    endif
                    !
                 else if(vTier == 4)then
                    !
                    lv_Ssr=vTargetRelease_a   
                    !
                    if(T%year <= 2007)then
                      call balanceContents(lv_balanceamount,vTier,lv_Ssr)
                    else
                      ! new on 03.28.12
                        if(lvd_Pm < 11.4049)then
                          call balanceContents(lv_balanceamount,vTier,lv_Ssr)
                        else
                          call targetElevations(T,vTier,lv_balanceamount,lv_Ssr)
                        endif
                    endif
                    !
                 else 
                    !
                    call balanceContents(lv_balanceamount,vTier,lv_Ssr)
                    !
                 endif
                !
                ! Hard coded.  Releases were not according to the plan that I saw
                ! ----------------------------------------------------------------
                if(T%year == 2002)lv_Ssr=7.795931
                if(T%year == 2004)lv_Ssr=8.473741
                if(T%year == 2008)lv_Ssr=9.123499
                !
                ! ====================================================================
                !
            end subroutine threshold_b
            !--------------------------     
            subroutine targetElevations(T,lvi_tier,lv_balanceamount,lv_Ssr)
                integer :: lvi_tier
                real :: lvf_powell_elevation
                real :: lvf_useElevation
                real :: state
                real :: lvf_actualStorage,lvf_diffStorage,lvf_targetStorage
                real(8) :: lv_balanceamount
                real(8) :: lv_Ssr
                real(8) :: vTargetRelease_a=8.23
                real,parameter :: lvp_low=7.0
                real,parameter :: lvp_mid=9.0

                real,parameter :: lvp_powellMax=27.8659
 
                type(runTime)T
                ! ==============
                  !
                    state=vState_Ba_maf(T%year)
                   lvf_powell_elevation=0
                  if(state < lvp_powellMax)then    
                    call elevationsPowell(vState_Ba_maf(T%year),lvf_powell_elevation)
                  endif
                  !
                    if(T%year < 2026)then
                     ! Table page 51
                     if(T%year == 2008)lvf_useElevation=3636
                     if(T%year == 2009)lvf_useElevation=3639 
                     if(T%year == 2010)lvf_useElevation=3642 
                     if(T%year == 2011)lvf_useElevation=3643 
                     if(T%year == 2012)lvf_useElevation=3645 
                     if(T%year == 2013)lvf_useElevation=3646 
                     if(T%year == 2014)lvf_useElevation=3648 
                     if(T%year == 2015)lvf_useElevation=3649 
                     if(T%year == 2016)lvf_useElevation=3651 
                     if(T%year == 2017)lvf_useElevation=3652 
                     if(T%year == 2018)lvf_useElevation=3654 
                     if(T%year == 2019)lvf_useElevation=3655 
                     if(T%year == 2020)lvf_useElevation=3657 
                     if(T%year == 2021)lvf_useElevation=3659 
                     if(T%year == 2022)lvf_useElevation=3660 
                     if(T%year == 2023)lvf_useElevation=3662 
                     if(T%year == 2024)lvf_useElevation=3663 
                     if(T%year == 2025)lvf_useElevation=3664 
                     !
                     ! Verified on 03.08.12 DAS
                     call stateFromElevationPowell(lvf_targetStorage,lvf_useElevation)
                     !
                     lvf_actualStorage=vState_Ba_maf(T%year)
                     ! 03.26.12
                      lvf_diffStorage=0
                      !
                      if(lvf_actualStorage < lvf_targetStorage)then
                       lvf_diffStorage=lvf_targetStorage-lvf_actualStorage
                        if(lvf_diffStorage < lv_balanceamount)then
                          ! Release more to get Mead to equilibrium
                          if(0 < lv_balanceamount)then
                           lv_Ssr=max(lvp_low,min(lvp_mid,max(lvp_low+lv_balanceamount,vTargetRelease_a)))
                          else
                           lv_Ssr=max(lvp_low,min(lvp_mid,min(lvp_low+lv_balanceamount,vTargetRelease_a)))
                          endif
                        else
                         ! Release less if the difference in storage is > balance amount
                          lv_Ssr=max(lvp_low,min(lvp_mid,min(lvp_low+lvf_diffStorage,vTargetRelease_a)))

                        endif
                      else
                       call balanceContents(lv_balanceamount,lvi_tier,lv_Ssr)
                      endif
                    else ! 2025 < year
                      call balanceContents(lv_balanceamount,lvi_tier,lv_Ssr)
                    endif
              return
            end subroutine targetElevations
            ! -----------------------------

 
            ! --------------------------------------------------
            subroutine balanceContents(lvd_balance,tier,release)
                integer :: tier
                real(8) :: release
                real(8) :: lvd_balance
                real :: fRelease
                real, parameter :: vTarget=8.23
                real, parameter :: vLow=7.0
                real, parameter :: vMid=9.0
                real, parameter :: vHigh=9.5
                !
                ! -----------------------------------------
                    !
                    release=fRelease(tier,vLow,vMid,vHigh,vTarget,lvd_balance)
                    !
              return
            end subroutine balanceContents
            ! -----------------------------

            ! ------------------------------------------------
            subroutine elevationsPowell(state,lvf_powell_elev)
!                                           Sum of        Mean               Approx
!           Source                    DF     Squares      Square    F Value    Pr > F
!
!           Model                      2     3304288     1652144    2.323E8    <.0001
!           Error                    338      2.4037     0.00711
!           Corrected Total          340     3304290
!
!
!                                                Approx
!                  Parameter      Estimate    Std Error    Approximate 95% Confidence Limits
!
!                  B0                382.8       0.3532       382.1       383.5
!                  B1               0.2136     0.000135      0.2134      0.2139
!                  B2               2931.0       0.3783      2930.3      2931.7
!                   y = B2 + B0* volume**B1;

!               State in units: maf
!               elevations in units: feet (msl)
!               New analyses on 04.02.12 DAS
               real,parameter :: lvf_slope=0.2136
               real,parameter :: lvf_scaling=382.8
               real,parameter :: lvf_intercept=2931.0
               real,parameter :: lvp_powellMaxElevation=3710

               real :: lvf_powell_elev
               real(8) :: state
                !
                 lvf_powell_elev=0
                if(1.89500 <= state)then
                  if(state <= 27.8659)then
                    lvf_powell_elev=anint(lvf_intercept + lvf_scaling*state**lvf_slope)
                  else
                    lvf_powell_elev=anint(lvf_intercept + lvf_scaling*27.8659**lvf_slope)
                  endif
                else
                    lvf_powell_elev=anint(lvf_intercept + lvf_scaling*1.89500**lvf_slope)
                endif
                !
                if(lvp_powellMaxElevation < lvf_powell_elev)lvf_powell_elev=lvp_powellMaxElevation
                !
              return
            end subroutine elevationsPowell
            ! -----------------------------

            ! --------------------------------------------------------
            subroutine stateFromElevationPowell(state,lvf_powell_elev)
               real,parameter :: lvf_slope=0.2136
               real,parameter :: lvf_scaling=382.8
               real,parameter :: lvf_intercept=2931.0

               real :: lvf_powell_elev
               real :: state
                !
                state=((lvf_powell_elev - lvf_intercept) * (1./lvf_scaling))**(1/lvf_slope) 
                !
              return
            end subroutine stateFromElevationPowell
            ! --------------------------------------
           subroutine elevationsMead(state,lvf_mead_elev)

!
!                                           Sum of        Mean               Approx
!           Source                    DF     Squares      Square    F Value    Pr > F
!
!           Model                      2     3132617     1566309    1717356    <.0001
!           Error                    332       302.8      0.9120
!           Corrected Total          334     3132920
!
!                                                Approx
!                  Parameter      Estimate    Std Error    Approximate 95% Confidence Limits
!
!                  B0                178.1       1.4980       175.1       181.0
!                  B1               0.3420      0.00161      0.3388      0.3452
!                  B2                665.5       1.7903       662.0       669.0
!                   y = B2 + B0* volume**B1;

!               State in units: maf
!               elevations in units: feet (msl)
!              04.02.12 DAS
               ! ====================================
               real,parameter :: lvf_slope=0.3420
               real,parameter :: lvf_scaling=178.1
               real,parameter :: lvf_intercept=665.5
               real,parameter :: lvp_meadMaxElevation=1229

               real :: lvf_mead_elev
               real(8) :: state
                !
                 lvf_mead_elev=0
                if(2.03500 <= state)then
                  if(state <= 29.4182)then
                    lvf_mead_elev=anint(lvf_intercept + lvf_scaling*state**lvf_slope)
                  else
                    lvf_mead_elev=anint(lvf_intercept + lvf_scaling*29.4182**lvf_slope)
                  endif
                else
                 lvf_mead_elev=anint(lvf_intercept + lvf_scaling*2.035**lvf_slope)
                endif
                !
                if(lvp_meadMaxElevation < lvf_mead_elev)lvf_mead_elev=lvp_meadMaxElevation
                !
              return
            end subroutine elevationsMead
            ! -----------------------------


        ! ---------------------------------
        subroutine aModifyStorage_bb(T,wsb) 
            
            integer :: lvi_tract
            real(8) :: lv_State_bb
            real(8) :: lv_Evap_bb
            real(8) :: fEvaporation_b
            !
            real(8) :: lv_overflow_PowellToMead  ! Overflow from the original powersim flow variable
            !
            real(8) :: lv_allocation_nv,lv_allocation_ca,lv_allocation_az,lv_allocation_mx
            real(8) :: vNallocation_nv,vNallocation_ca,vNallocation_az,vNallocation_mx,lv_allocation_normal
            real(8) :: vSsmult_nv,vSsmult_az,vSsmult_mx
            real(8) :: lv_predictedmead,lv_shortfall_b
            real(8) :: lv_Mead_Add_Flow
            !
            real(8) :: lv_OverFlow_bb
            real(8) :: lv_Sss
            real(8) :: lv_SevenStatesLCshortage
            real(8) :: lvd_preCAavail,lvd_postCAavail,lvd_postMXavail
            real(8) :: lv_available
            !
            real :: lvf_meadElevation,lvf_powellElevation
            !
            real :: lvf_fluxMead,lvf_fluxNormalDist
            real :: lvf_check1,lvf_check2
            real :: lvi_errorLevel=0.001 ! thousandth of a percent error in allocations
            logical :: lvl_meadFlag,lvl_normalShortage,lvl_abnormalDifference
            !
            data vNallocation_nv,vNallocation_ca,vNallocation_az,vNallocation_mx /0.3,4.4,2.8,1.5/   
                                                              ! normal flow allocations/ designations
            data vSsmult_nv,vSsmult_az,vSsmult_mx /0.0325,0.8,0.1675/    
!            data vSsmult_nv,vSsmult_az /0.03903904,0.96096096/  ! Revised on 05.28.10 das using CRC of NV notes from the workshop
                                        ! 1050 to 1075 elev - shortages are 13,000 AF NV and 320,000 AF AZ
                                        ! 1025 to 1050 elev - shortages are 17,000 AF NV and 400,000 AF AZ
                                        ! below 1025   elev - shortages are 20,000 AF NV and 480,000 AF for AZ         
            !
            type(watershed_B)::wsb
            type(runTime)T
            ! ============
               !
                lvl_normalShortage=.false.
                lvl_abnormalDifference=.false.
                !
                wsb%lv_AZshareCO=0.
               lv_allocation_normal=vNallocation_nv+vNallocation_ca+vNallocation_az+vNallocation_mx
               !
                 lv_Evap_bb=fEvaporation_b(vState_Bb_maf(T%year))
 
                ! Overflow from Powell plus proportion of "Lees's ferry" flow directly to Mead - See Tim's original code
                 lv_overflow_PowellToMead=0.
                lv_overflow_PowellToMead=wsb%lv_OverFlow_ba(T%year)
                 lv_Mead_Add_Flow=0.
                lv_Mead_Add_Flow=lv_overflow_PowellToMead+wsb%lv_flowAdjustToMead(T%year)
                !
                ! http:/www.drought.gov/imageserver/NIDIS/workshops/copilot/Fulp_Powell_Mead_NIDIS2008-10-01.pps slide 6
                ! and, RecordofDecision.pdf - December 2007, The Secretary of the Interior, Washington
                !      Robert Johnson, Commissioner, Bureau of Rec, and Dirk Kempthorne,Sec of the Dept of Interior
                  !
                 ! delta state
                 lv_State_bb=0.
                lv_State_bb=vState_Bb_maf(T%year)+wsb%lv_BaToBb(T%year)+ lv_Mead_Add_Flow -lv_Evap_bb
                !
                 lvf_fluxMead=0
                lvf_fluxMead= wsb%lv_BaToBb(T%year)+ lv_Mead_Add_Flow -lv_Evap_bb
                !
                ! 03.26.12 changed the definition
                 lv_predictedmead=max(0,vState_Bb_maf(T%year)+ lvf_fluxMead-lv_allocation_normal)
                !
                 lvf_fluxNormalDist=0
                lvf_fluxNormalDist=lvf_fluxMead-lv_allocation_normal
                ! To check for mass balance
                 lv_available=0.
                 lvd_preCAavail=0.
                lv_available=vState_Bb_maf(T%year)-li_meaddeadpool+wsb%lv_BaToBb(T%year)+ lv_Mead_Add_Flow -lv_Evap_bb
                lvd_preCAavail=lv_available
                 !
                 lvf_meadElevation=0.
                 go_meadElevationPred=0
                call  elevationsMead(lv_predictedmead,lvf_meadElevation)
                go_meadElevationPred=nint(lvf_meadElevation)

                 call  sevenstates(T,lvf_meadElevation,lv_predictedmead,lv_SevenStatesLCshortage)
                 lv_Sss=lv_SevenStatesLCshortage
                 !
                 ! New analysis of the shortfall
                  lv_shortfall_b=0.
                 lv_shortfall_b=max(0.,-lv_available+lv_allocation_normal-lv_Sss)

                 ! 12.02.10 das new code
                 lv_Sss=lv_SevenStatesLCshortage
                 !
                 wsb%lv_AZshortageCO=lv_SevenStatesLCshortage*vSsmult_az
                !
                lv_allocation_ca=vNallocation_ca
                 lv_allocation_ca=0
 lvi_tract=0
                if(li_meaddeadpool < lv_State_bb)then
                    if(li_meaddeadpool < lv_State_bb-lv_allocation_ca)then
                      vState_Bb_maf(T%year)=lv_State_bb-vNallocation_ca
                        if(vNallocation_ca < lvf_fluxMead)then
                         lv_allocation_ca=vNallocation_ca
                        else
                          lv_allocation_ca=max(0,lvf_fluxMead)
                        endif
                    else
                      vState_Bb_maf(T%year)=li_meaddeadpool
                      lv_allocation_ca=lvf_fluxMead
                    endif
                else
                  vState_Bb_maf(T%year)=li_meaddeadpool
                  lv_allocation_ca=0.
                endif
                 !
                lv_allocation_nv=0.
                lv_allocation_az=0.
                lv_allocation_mx=0.
                !
                ! lvf_fluxMead
                lvd_postCAavail=max(0., vState_Bb_maf(T%year)-li_meaddeadpool)
               ! New on 03.28.12
                if(lv_allocation_ca < lvd_preCAavail)then
                else
                 lv_allocation_ca=lvd_preCAavail
                 lvd_postCAavail=0
                endif

                if(0 < lv_Sss)then
                  if(li_meaddeadpool < vState_Bb_maf(T%year))then
                   !
                     lvd_postMXavail=0.
                    if(0 < lv_shortfall_b)then
                    !
lvi_tract=2
                    ! Abnormal operations of a shortage- i.e. not enough water to meet shortage allocations
                        if(0 < lvd_postCAavail)then
                         lvd_postMXavail=lvd_postCAavail
                         ! 03.24.12
                         lv_allocation_nv=max(0.,(lvd_postMXavail*vSsmult_nv))
                         lv_allocation_az=max(0.,lvd_postMXavail*vSsmult_az)
                         ! 04.04.12 added mexico back in
                         lv_allocation_mx=max(0.,(lvd_postMXavail-(lv_allocation_nv+lv_allocation_az)))
                        endif
                    else
lvi_tract=3
                     !
                     lvl_normalShortage=.true.
                     !
                     ! "Normal" operations of a shortage
                     ! -----------------------------------------------------------------
!                     lv_allocation_mx=vNallocation_mx 
                     ! 04.04.12 added mexico back in
                     lv_allocation_mx=max(vNallocation_mx-vSsmult_mx*lv_Sss,0.)
                     lv_allocation_nv=max(vNallocation_nv-vSsmult_nv*lv_Sss,0.)
                     lv_allocation_az=min(2.8,max(vNallocation_az-vSsmult_az*lv_Sss,0.))
                     !
                    endif
                    !
                  else
                    !
                    ! Mead At dead pool
                    ! -----------------------------------------------
                   vState_Bb_maf(T%year) = li_meaddeadpool
                    !
                    lvl_abnormalDifference=.true.
                    !
                   if(gvl_WriteToDisk)&
                    write(7,*)"Mead Dead Pool- line 1185 in WaterShed_CO.f90"
                  !
lvi_tract=4
                  endif
                  !
                else
                    !
                   if(lvd_postCAavail >= vNallocation_nv+vNallocation_az+vNallocation_mx)then
                     lv_allocation_nv=vNallocation_nv
                     lv_allocation_az=vNallocation_az
                     lv_allocation_mx=vNallocation_mx
lvi_tract=5
                   else
                     if(gvl_WriteToDisk)&
                    write(7,*)"Mead Error- line1199 in WaterShed_CO.f90"

                   endif
                endif
                ! ---------------------------------------------------------------------------------------------------
                 !
                 if(lvl_abnormalDifference)then
                    ! Mead at Dead Pool
                 else
                  vState_Bb_maf(T%year) = vState_Bb_maf(T%year) - (lv_allocation_nv+lv_allocation_az+lv_allocation_mx)
                 endif
                 !
                   lv_OverFlow_bb=0
                 if(0 < lv_Sss)then
                   !
                    lvf_check1=lv_allocation_nv+lv_allocation_az+lv_allocation_mx
                    lvf_check2=lvd_postCAavail
                    call sCompareControl(lvf_check1,lvf_check2,lvi_errorLevel,lvl_meadFlag)
                    if(lvl_normalShortage)then

                    else
                     if(lvl_meadFlag)then
                        if(gvl_WriteToDisk)&
                        write(7,*)T%year,"Mead Error in allcations- line 1221 in WaterShed_CO.f90"
                        write(7,*)lv_allocation_nv,lv_allocation_az,lv_allocation_mx,lvd_postCAavail,lvi_tract
                     endif
                    endif
                else
                      !
                      if(li_meadmax < vState_Bb_maf(T%year))then
                       lv_OverFlow_bb=vState_Bb_maf(T%year)-li_meadmax
                       vState_Bb_maf(T%year) = li_meadmax
                      endif
                    !
                endif
                ! ===================================================================================================
                !
                 lvf_powellElevation=0.
                 go_powellElevation=0
                call  elevationsPowell(vState_Ba_maf(T%year),lvf_powellElevation)
                go_powellElevation=nint(lvf_powellElevation)

                 lvf_meadElevation=0.
                 go_meadElevation=0
                call  elevationsMead(vState_Bb_maf(T%year),lvf_meadElevation)
                go_meadElevation=nint(lvf_meadElevation)

if(gvl_WriteToMyDisk)then
if(lvi_tract == 2 .or. lvi_tract == 4)then
write(100,*)gvi_COtrace,gv_indexyearCO,T%year,lvi_tract, vState_Bb_maf(T%year), &
 lvd_postCAavail,lv_allocation_az,lv_allocation_ca,lv_allocation_az+lv_allocation_nv+lv_allocation_mx
endif
endif
                ! ----------------------------------------------------------------------------------------------------
                !
                wsb%lv_AZshareCO=lv_allocation_az
              !
            return
        end subroutine aModifyStorage_bb
        !-------------------------------

        ! ---------------------------------------------------------
        subroutine sevenstates(T,lvf_meadElevation,lv_PMead,lv_SevenStatesLCshortage)
                !
                ! Live is "active"
                !
                ! Heretofore I was simulating with live volumes for the parameters, but
                ! modeling total, so I threshold volumes are off...
                !
!              real(8) :: vMeadVolThresh_2=4.33  ! Mead < 1,025 feet
!              real(8) :: vMeadVolThresh_3=5.8   ! Mead at 1,025 feet
!              real(8) :: vMeadVolThresh_4=7.47  ! mead at 1,050 feet 
!              real(8) :: vMeadVolThresh_5=9.37  ! mead at 1,075 feet (live, not total)
              ! 04.02.12 DAS
              real(8) :: vMeadVolThresh_2=7.83602  ! Mead < 1,025 feet
              real(8) :: vMeadVolThresh_3=7.83602   ! Mead at 1,025 feet
              real(8) :: vMeadVolThresh_4=9.5059 ! mead at 1,050 feet 
              real(8) :: vMeadVolThresh_5=11.4049  ! mead at 1,075 feet (total)
              !
              real,parameter :: lvp_StepOne=1075
              real,parameter :: lvp_StepTwo=1050
              real,parameter :: lvp_StepThree=1025
              !
              real(8) :: lv_PMead
              real(8) :: lv_SevenStatesLCshortage
              real :: lvf_meadElevation
              logical :: lvl_mass=.false.
                !
              type(runTime)T
               ! ===============
                !           
                 lv_SevenStatesLCshortage=0.
               if(lvl_mass)then
                 if(lv_PMead < vMeadVolThresh_2)then
                   lv_SevenStatesLCshortage=0.6
                 else
                   if(lv_PMead < vMeadVolThresh_3)then
                    lv_SevenStatesLCshortage=0.5 ! w/o mexico
                    lv_SevenStatesLCshortage=0.6

                   else
                    if(lv_PMead < vMeadVolThresh_4)then
                     lv_SevenStatesLCshortage=0.417 ! w/o mexico
                     lv_SevenStatesLCshortage=0.5

                    else
                     if(lv_PMead < vMeadVolThresh_5)then
                      lv_SevenStatesLCshortage=0.333 ! w/o mexico
                      lv_SevenStatesLCshortage=0.4

                     else
                      lv_SevenStatesLCshortage=0.          
                     endif
                    endif
                   endif
                 endif               
               else
                if(lvf_meadElevation <=lvp_StepThree)then
                   lv_SevenStatesLCshortage=0.6
                else
                    if(lvf_meadElevation <=lvp_StepTwo)then
                     lv_SevenStatesLCshortage=0.5

                    else
                        if(lvf_meadElevation <=lvp_StepOne)then
                          lv_SevenStatesLCshortage=0.4
                        else
                          lv_SevenStatesLCshortage=0.
                        endif
                    endif
                endif
               endif
              !
           return
        end subroutine sevenstates
        !-------------------------

        ! ------------------------------
        subroutine designations_B(T,wsb)

            real(8) :: vPreCap
            real :: lv_onRiver,cv_onRiver=1.2
            real(8) :: lv_CAPwater(gpi_lBY:gpi_uBY)
            real :: lv_capcapacity=2.17
            real :: lv_capevapconst=0.062 ! changed on 05.24.10 from 0.07 das
            real :: lv_capmaricopashare=0.75
            type(watershed_B)::wsb
            type(runTime)T
            ! ===============
             ! Tim's original code
!              vYuma=min(wsb%lv_AZshareCO/2,1.2)
!              vPreCap=wsb%lv_AZshareCO-vYuma
              !
              !   Added on 06.09.10 based on a talk last night by Dee Fuerst at the monthly
              ! AHS meeting in PHX- CAP has to take 90% of the AZ shortage.. On-river take 10%
              lv_onRiver=min(wsb%lv_AZshareCO,cv_onRiver-(0.1*wsb%lv_AZshortageCO))
              vPreCap=max(wsb%lv_AZshareCO-lv_onRiver,0)
              !
             if(vPreCap*(1.-lv_capevapconst) <= lv_capcapacity)then
                lv_CAPwater(T%year)=vPreCap*(1.-lv_capevapconst)
             else
                lv_CAPwater(T%year)=lv_capcapacity*(1.-lv_capevapconst)
             endif
              !
            wsb%lv_CAPmaricopa(T%year)=0.
            wsb%lv_CAPmaricopa(T%year)=lv_CAPwater(T%year)*lv_capmaricopashare
            wsb%lv_CAP(T%year)=lv_CAPwater(T%year)
            !
            go_CAP=nint(lv_CAPwater(T%year)*1e6)
            !
!write(3,*)"CAP",gvi_COtrace,gv_indexyearCO,T%year,wsb%lv_AZshareCO,lv_onRiver,go_CAP
            !
         end subroutine designations_B
        !-----------------------------

        ! ---------------------------------
        subroutine updateState_b(T,Bout,wsb)

                type(runTime)T
                type(RiverB)Bout
                type(watershed_B)::wsb
                ! ===============
                 !
                  vState_Ba_maf(T%year+1)=vState_Ba_maf(T%year)
                  vState_Bb_maf(T%year+1)=vState_Bb_maf(T%year)
                  vState_B_maf(T%year)=vState_Ba_maf(T%year)+vState_Bb_maf(T%year)
                 !
                 Bout%bFlow=lv_flow_B_maf(T%year)
                 Bout%bCAPmaricopa=wsb%lv_CAPmaricopa(T%year)
                 Bout%bCAP_maf=wsb%lv_CAP(T%year)
                 Bout%bFlowRaw=go_riverFlowCO ! Raw runoff after climate and drought factor
                 !
                 ! Send to interface
                 go_AZshareCO=nint(wsb%lv_AZshareCO* (1./gpd_acftTomaf))
                 !
        end subroutine updateState_b
        ! --------------------------

        ! -----------------------
        subroutine outinitialB(T) 

           type(runTime)T
          ! ===============
            !
          if(T%year /= T%startyear)then
          else
           !
           ! -------------------------------------------------------------------------------------
           if(gvl_WriteToDisk)then
             write(9,*) ""
             write(9,*) "                           Colorado River Variables                         "
             write(9,*) "----------------------------------------------------------------------------"
            if(2000 < T%year)then
             write(9,*) "INITIAL STORAGE for the lower basin (maf):     ",lvf_initial_state_Powell+ &
                                                                           lvf_initial_state_Mead,"-",T%year
             write(9,*) "INITIAL STORAGE for Powell (maf):              ",lvf_initial_state_Powell
             write(9,*) "INITIAL STORAGE for Mead (maf):                ",lvf_initial_state_Mead
            else
             write(9,*) "INITIAL STORAGE for the lower basin (maf):     ",vState_Ba_maf(T%year)+ &
                                                                        vState_Bb_maf(T%year),"-",T%year
             write(9,*) "INITIAL STORAGE for Powell (maf):              ",vState_Ba_maf(T%year)
             write(9,*) "INITIAL STORAGE for Mead (maf):                ",vState_Bb_maf(T%year)
            endif
             write(9,*) " "
             write(9,*) "INDEX YEAR for the Colorado River was:         ",gv_indexyearCO 
             write(9,*) "CO flow for the year:                          ",li_iflowCOacft(gv_dataCO,lv_recordCO(gv_dataCO)+1)
             write(9,*) " "
           
             write(9,*) "The CLIMATE FACTOR for the Colorado River:     ",gv_climatefactorCO
          
            
             write(9,*) "CO drought factor:     ",gv_droughtfactorCO
             write(9,*) "CO drought year starts:",gv_droughtyearCO,   " To initiate drought"
             write(9,*) "# of drought years:    ",li_numdroughtyearsCO
            
             write(9,*) ""
             write(9,*) "       Some Colorado River constants used in the model"
             write(9,*) " =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  "
             write(9,*) "Lake Mead maximum storage (maf):               ",li_meadmax
             write(9,*) "Lake Mead dead pool storage (maf):             ",li_meaddeadpool
             write(9,*) "Lake Powell maximum storage (maf):             ",li_powellmax
             write(9,*) "Lake Powell dead pool storage (maf):           ",li_powelldeadpool
             write(9,*) "Yuma allocation of the Colorado River(maf):    ",li_yumaallocation
             write(9,*) "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
          else
          endif
         endif
          !
        end subroutine outinitialB
       ! --------------------------

        ! --------------------
        subroutine outputsB(T)

            type(runTime)T
           !==============
            ! Send to the interface
            go_StateCO=NINT((vState_Ba_maf(T%year)+vState_Bb_maf(T%year))*(1./gpd_acftTomaf))
            go_StatePowell=NINT(vState_Ba_maf(T%year)* (1./gpd_acftTomaf))
            go_StateMead=NINT(vState_Bb_maf(T%year)* (1./gpd_acftTomaf))
            !
            if(T%year == T%startyear)then
             if(gvl_WriteToDisk) &
             write(7,*)"  WaterShed_CO.f90"
            endif
            !
        end subroutine outputsB
       ! --------------------------
End Module lms_River_Ba
!
! =================================================================================================
  !
    subroutine sRiver_Ba(T,acft,Bout)
     use gm_ModelControl
      use lms_River_Ba
      !
      integer :: acft
      type(RiverB)Bout
      type(watershed_B)::wsb
      type(runTime)T
      ! ===============
        !
        call aFlow_b(T,acft)
        call aModifyFlow_ba(T)   ! Drought and climate adjustments
        call aModifyFlow_bb(T,wsb)   ! Direct (unregulated) flow to Mead from Powell
        call aModifyFlow_bc(T,wsb)   ! Upper Basin water use removed
        call reservoirs_b(T,wsb)
         !
        call updateState_b(T,Bout,wsb)
        call outinitialB(T)
        call outputsB(T)
        !
    end subroutine sRiver_Ba
   !---------------------------
! =================================================================================================
! E.O.F.