!
! File is WaterShed_SVT.f90
!
! This file simulates the Salt-Verde-tonto River System.  Mostly regulates which flow data are
! used in the simulation. And, some reservoir operations are managed here.
!
! Global OUTPUTS:

!
! Local OUTPUTS:
!   
! Local INPUTS:
!           
!---------------------

! created on 09.30.09
!
! david arthur sampson
! last write was: 02.10.12
! -------------------------------------------------------
!
! ==========================================================================================
!
Module lm_River_Aa
 use gm_ModelControl
  use gm_GlobalData

   implicit none
    !
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
  contains
      subroutine initWSA()
       call openFiles_a()
       call readParms_a()
       call readFiles_a()
       call initialState_a()
      end subroutine initWSA
      ! --------------------

        ! ----------------------
        subroutine openFiles_a()
 
          character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
          if(gpl_release)lvc_dataPath=trim(gvc_DPath)
          !
           LU=15
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\BofR_SVTbase.txt'),exist=lexist)
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\BofR_SVTbase.txt'),status="old")
          else
           goto 10
          endif
          !
           LU=16
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_BofR.txt'),exist=lexist)
           if(lexist)then
            open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_BofR.txt'),status="old")
           else
            goto 10
           endif
          !
          LU=17
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_paleo.txt'),exist=lexist)
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_paleo.txt'),status="old")
          else
           goto 10
          endif
          !
          LU=18
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_scenario.txt'),exist=lexist)
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_scenario.txt'),status="old")
          else
           goto 10
          endif
           ! DAS
           LU=19
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVT_doy.txt'),exist=lexist)
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVT_doy.txt'),status="old")
          else
           goto 10
          endif
          !
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\Initial_storage.txt'),exist=lexist)
          LU=23
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\Initial_storage.txt'),status='unknown')
          else
           goto 10
          endif
          !
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_SVT.dat'),exist=lexist)
          LU=31
          if(lexist)then
           open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_SVT.dat'),status='old')
          else
           goto 10
          endif
        
            LU=0
10         continue
            gv_exceptionCode=LU
            if(LU .ne.0)then
             if(gvl_WriteToDisk)then
              write(*,*)"Data for the Salt-Verde are missing; logical unit is= ", LU, " See log file"
              write(7,*)"SVT error on reading input"
              write(7,*)" Units are:", LU
              write(7,*)" "
              write(7,*)" open(12,file='App_Data\Data\SVTRivers_BofR.txt',status=old)"
              write(7,*)" open(23,file='App_Data\Data\Initial_storage.txt',status='unknown')"
              write(7,*)" open(31,file='App_Data\Parameters\parm_SVT.dat',status='old')"
              close(7)
             endif
            endif
         return
        end subroutine openFiles_a
       ! -------------------------

        ! ----------------------
        subroutine readFiles_a()
          use gm_GlobalData
            !
            integer :: rec
            integer :: i,j
            integer :: ios 
            integer :: iyear
            integer :: gvi_flowSVT(gpi_dailySVTrec,3)
            !
            real(8) :: B(2000:2010)
            real(8) :: C(2000:2010)
            real :: temp
            ! -----------------------------------------
            !
            ios=0
            rec=0
            LU=0
            !
            !-----------------------------------------------------
            !
            LU=15
            do rec=1,11,1
              read(LU,*,err=2)temp,lvd_iflowSVTbase_AF(rec)
             temp=temp
            end do
             close(LU)
             ! 1st record is nominally 1330 AD

             LU=16
             lv_recordSVT(1)=10
             do rec=1,63,1
              read(LU,*,err=1)li_iyear(1,rec),li_iflowSVTacft(1,rec)
             end do
             close(LU)
             lv_recordSVT(1)=(gv_indexyearSVT-li_iyear(1,1))+1 

             LU=17
             lv_recordSVT(2)=644
             do rec=1,676,1
              read(LU,*,err=1)li_iyear(2,rec),li_iflowSVTacft(2,rec)
             end do
             close(LU)
             lv_recordSVT(2)=(gv_indexyearSVT-li_iyear(2,1))+1 

             LU=18
             do rec=1,75,1 ! 2011 through 2085
              read(LU,*,err=1)li_iyear(3,rec),li_iflowSVTacft(3,rec)
             end do
             close(LU)
             lv_recordSVT(3)=1 
              li_iyear(3,1)=1
              !
              ! Units cfs
              LU=19
              read(LU,*,err=1)((gvi_flowSVT(i,j),j=1,3),i=1,24471)
             close(LU)
                ! assign the input to a global array listed in WaterSimDCDC.txt
                gvf_flowSVT=gvi_flowSVT

2           continue
            if(ios >0)then
             LU=14
            goto 1000
            endif
1           continue
            if(ios >0)then
             LU=12
            goto 1000
            endif
            !
            LU=23
            do i = 2000,2010,1
             read(LU,*,err=7,iostat=ios)iyear,li_initstorageSVT(i),B(i),C(i)
             iyear = iyear*1 ! place holders 
             B(i)=B(i)*1
             C(i)=C(i)*1
            end do
            rewind(23)
             lv_firstYear=2000
7           continue
            close(23)
            if(ios >0)then
            LU=23
            goto 1000
            endif
          return
          1000 continue
           if(gvl_WriteToDisk)&
            write(7,*)" Error reading file input: WaterShed_SVT.f90- logical unit is:", LU
        end subroutine readFiles_a
        ! -------------------------

        ! ----------------------
        subroutine readParms_a()
            !
            real(8) :: vStorageCapacityV,vStorageCapacityST
            integer :: li_numdroughtyearsSVT
            !
            read(31,*)gv_indexyearSVT
            read(31,*)gv_droughtyearSVT
            read(31,*)gv_climatefactorSVT
            read(31,*)li_numdroughtyearsSVT
            read(31,*)gv_droughtfactorSVT
            read(31,*)li_normalflowacftperacre
            read(31,*)li_horsemesamax
            read(31,*)li_mormanflatmax
            read(31,*)li_rooseveltmax
            read(31,*)li_stewartmountainmax
            read(31,*)li_bartlettmax
            read(31,*)li_horseshoemax
            read(31,*)li_deadpoolSVT
            !
            close(31)
            gv_droughtyearendSVT=gv_droughtyearSVT+li_numdroughtyearsSVT
            !
            vStorageCapacityST=li_horsemesamax+li_mormanflatmax+li_rooseveltmax+ &
                li_stewartmountainmax
            vStorageCapacityV=li_bartlettmax+li_horseshoemax
            lv_storageCapacity=vStorageCapacityST+vStorageCapacityV
            !
           return
        end subroutine readParms_a
       ! -------------------------

        ! -------------------------
        subroutine initialState_a()
            ! 
            gv_dataSVT=1
            go_riverFlowSVT=li_iflowSVTacft(gv_dataSVT,lv_recordSVT(gv_dataSVT))
            lv_State_A_maf(2000)=li_initstorageSVT(2000)*lv_storageCapacity
            lv_State_A_maf(2001)=li_initstorageSVT(2001)*lv_storageCapacity
            lv_State_A_maf(2006)=li_initstorageSVT(2006)*lv_storageCapacity
            !
            go_StateSVT=nint(lv_State_A_maf(2006)*1e6)
            go_deliveriesSVT=nint(0.7923488*1e6)
            ! ~
        end subroutine initialState_a
        ! ---------------------------
!
End Module lm_River_Aa
!
Module lms_River_Aa
 use gm_ModelControl
  use gm_GlobalData
   use gm_TypeControl
    use gm_Global
     use gm_Euler

    implicit none
   ! -------------
    !
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
    type watershed_A
     real(8) :: lvd_ExpStorage_A_maf_yr(gpi_lBY:gpi_uBY),lvd_PrereleaseExcess_A_maf_yr(gpi_lBY:gpi_uBY)
     real(8) :: lvd_releaseExcess_A_maf_yr(gpi_lBY:gpi_uBY)
     real(8) :: lvd_SRPrelease_maf_yr(gpi_lBY:gpi_uBY)
     real(8) :: gvd_allocateNCS_maf_yr(10),lvd_1,lvd_2,lvd_3
    end type watershed_A
    !
    type(Operations) :: ltSVT
    !
    ! =============================================================================================
   contains
      subroutine aFlow_a(T,acft)
        !
        logical :: lvl_noTrace=.false.
        logical :: lvl_start2000
        integer :: acft
        integer :: i,j,lvi_totalyears 
        integer :: lvi_addRecords
        integer :: lvi_addRec

        type(runTime)T
       ! ===============
        !
        lvl_start2000=.true.
        lvi_addRec=0
        lvi_addRecords=0
        if(gv_dataSVT < 1)gv_dataSVT=1
        !
        if(0 < acft)then
          ! Reserved for test simulations
         lv_maf_yr(T%year)=acft*1.*gpd_acftTomaf
        else
         !
          if(T%year == T%startyear)then
            do i = 1,300,1
             do j = 1,3,1
              lvi_flowSVTacftMod(j,i)=0
             end do
            end do
            vArecA=641
           vArecA=(gv_indexyearSVT-li_iyear(gv_dataSVT,1)) 
          ! 10.22.10 das
          ! ===================================================================
           lvi_totalyears=T%endyear-T%startyear
          !
            lvl_noTrace=.false.
           if(gv_dataSVT == 1)then
           else if(gv_dataSVT == 2)then
           else if(gv_dataSVT == 3)then
             lvl_noTrace=.true.
           endif
            !
            if(lvl_noTrace)then
              ! Reserved for future code changes
                do i = 1,11,1
                  lvi_flowSVTacftMod(gv_dataSVT,i)=lvd_iflowSVTbase_AF(i)
                end do
                do j = 12,85,1
                    lvi_flowSVTacftMod(gv_dataSVT,j)=li_iflowSVTacft(gv_dataSVT,j-10) 
                end do
              vArecA=0
            else
              !
              if(lvl_start2000)then
                do i = 1,11,1
                  lvi_flowSVTacftMod(gv_dataSVT,i)=lvd_iflowSVTbase_AF(i)
                end do
                  if(gv_dataSVT == 1)then
                   do j = 12,lvi_totalyears,1
                      lvi_flowSVTacftMod(gv_dataSVT,j)=li_iflowSVTacft(gv_dataSVT,vArecA+1+lvi_addRecords)
                      lvi_addRecords=lvi_addRecords+1
                      if(vArecA+lvi_addRecords > vArecA+25 )then
                        lvi_addRecords=0
                        lvi_flowSVTacftMod(gv_dataSVT,j)=li_iflowSVTacft(gv_dataSVT,vArecA+1+lvi_addRecords)
                        lvi_addRecords=lvi_addRecords+1
                      endif
                    end do
                  else
                    do j = 12,lvi_totalyears+vArecA,1
                      lvi_flowSVTacftMod(gv_dataSVT,j)=li_iflowSVTacft(gv_dataSVT,vArecA+1+lvi_addRecords)
                      lvi_addRecords=lvi_addRecords+1
                      if(vArecA+lvi_addRecords > vArecA+25 )then
                        lvi_addRecords=0
                        lvi_flowSVTacftMod(gv_dataSVT,j)=li_iflowSVTacft(gv_dataSVT,vArecA+1+lvi_addRecords)
                        lvi_addRecords=lvi_addRecords+1
                      endif
                    end do
                  endif
                vArecA=0 + lvi_addRec
              else           
                   do j = 1,lvi_totalyears,1
                      lvi_flowSVTacftMod(gv_dataSVT,j)=li_iflowSVTacft(gv_dataSVT,vArecA+1+lvi_addRecords)
                      lvi_addRecords=lvi_addRecords+1
                      if(vArecA+lvi_addRecords > vArecA+25 )then
                        lvi_addRecords=0
                        lvi_flowSVTacftMod(gv_dataSVT,j)=li_iflowSVTacft(gv_dataSVT,vArecA+1+lvi_addRecords)
                        lvi_addRecords=lvi_addRecords+1
                      endif
                   end do
                vArecA=0
              endif ! end of start2000
            endif  ! end of notrace
         endif ! end of T%year == T%startyear
         ! =============================================================================
         !
         vArecA=vArecA+1
         !
         ! New code 10.22.10 das
         lv_maf_yr(T%year)=lvi_flowSVTacftMod(gv_dataSVT,vArecA)*gpd_acftTomaf !/1e6
         !
        if(2000 < T%year)then
          if(lvl_noTrace)then
          else
            if(1 < vArecA)then
             lv_maf_yr(T%year-1)=lvi_flowSVTacftMod(gv_dataSVT,vArecA-1)*gpd_acftTomaf
            else
             lv_maf_yr(T%year-1)=lvi_flowSVTacftMod(gv_dataSVT,vArecA)*gpd_acftTomaf
            endif
          endif
        else
         if(lvl_noTrace)then
          else
            if(1 < vArecA)then
             lv_maf_yr(T%year)=lvi_flowSVTacftMod(gv_dataSVT,vArecA-1)*gpd_acftTomaf
            else
             lv_maf_yr(T%year)=lvi_flowSVTacftMod(gv_dataSVT,vArecA)*gpd_acftTomaf
            endif
          endif
        endif
         !
         if(lvi_flowSVTacftMod(gv_dataSVT,vArecA) <=0)then  
           ! catch this exception
           lv_maf_yr(T%year)=0.
           goto 100
           !
         endif
        endif ! endif for acft < 0
        !
       return
100     continue
         if(gvl_WriteToDisk)&
          write(7,*)T%year,"Flow for the SVT is zero or less than zero- line 431-WaterShed_SVT.f90"
      end subroutine aFlow_a
      !---------------------

      ! -------------------------
      subroutine aModifyFlow_a(T)
        !
        integer :: startY=2020
        real :: lvf_modRunoff=1
        real :: lvf_reduce=41,lvf_fSES
        type(runTime)T
        ! ===============
         !
          if(gpl_validate)lvf_modRunoff=1.0

         lv_maf_yr(T%year)=lvf_modRunoff*lv_maf_yr(T%year)*gv_climatefactorSVT
         !
        if(gpl_SVT_SESDriven)then
          if(gpl_ClimateDriven)then
            if(0 < gvi_SVT_SES_reducePct)lvf_reduce=gvi_SVT_SES_reducePct
              if(50< lvf_reduce)lvf_reduce=50
                if(T%year == T%startyear)gvf_SVT_sesValue=gv_climatefactorSVT
                  call sSES(T,startY,gvf_SVT_sesValue,lvf_reduce,lvf_fSES)
                  gvf_SVT_sesValue=lvf_fSES
         !
          gv_climatefactorSVT=gvf_SVT_sesValue
         !
         lv_maf_yr(T%year)=lvf_modRunoff*lv_maf_yr(T%year)*gvf_SVT_sesValue
         !
          endif
        endif
        !
         if(T%year >= gv_droughtyearSVT)then
          if(T%year <=  gv_droughtyearendSVT)then
            lv_maf_yr(T%year)=lv_maf_yr(T%year)*gv_droughtfactorSVT
          endif
         endif
        ! ------------------------------------------------------------------
            !
            ! Note: 03.20.12
            ! ==============
            if(gpl_test_SRPrelease)lv_maf_yr(T%year)=1.5
            !
         !
         ! =================================================================
         ! Send to the Interface
         go_riverFlowSVT=NINT(lv_maf_yr(T%year)* (1./gpd_acftTomaf))
         !
        return
      end subroutine aModifyFlow_a
      !---------------------------

      ! -------------------------------
      subroutine expectedStorage(T,wsa)
            !
            integer :: i
            real(8) :: fEvaporation
            real(8) :: vEvap_a   
            real(8) :: lv_InitStorage_A
            real(8) :: lv_expected
             !
            type(watershed_A):: wsa
            type(runTime)T
            ! ===============
              !
              if(gvl_start)then
                do i = gpi_lBY,gpi_uBY,1
                  wsa%lvd_ExpStorage_A_maf_yr(i)=0.
                  wsa%lvd_PrereleaseExcess_A_maf_yr(i)=0.
                end do
              endif
              if(T%year == T%startyear)then
                if(2000 < T%year)then
                 lv_InitStorage_A=li_initstorageSVT(T%year)*lv_storageCapacity
                 lv_State_A_maf(T%year)=lv_InitStorage_A
                 lv_State_A_maf(T%year-1)=li_initstorageSVT(T%year-1)*lv_storageCapacity
                 !
                 vEvap_a=0.
                 vEvap_a=fEvaporation(lv_State_A_maf(T%year-1))
                 wsa%lvd_ExpStorage_A_maf_yr(T%year-1)=lv_State_A_maf(T%year-1)+lvi_flowSVTacftMod(gv_dataSVT,vArecA-1)*gpd_acftTomaf-vEvap_a
                else
                 lv_InitStorage_A=li_initstorageSVT(T%year)*lv_storageCapacity
                 lv_State_A_maf(T%year)=lv_InitStorage_A
                 lv_State_A_maf(T%year)=li_initstorageSVT(T%year)*lv_storageCapacity
                 !
                 vEvap_a=0.
                 vEvap_a=fEvaporation(lv_State_A_maf(T%year))
                 wsa%lvd_ExpStorage_A_maf_yr(T%year)=lv_State_A_maf(T%year)+lvi_flowSVTacftMod(gv_dataSVT,vArecA)*gpd_acftTomaf-vEvap_a
                endif
             endif
              !
               vEvap_a=0.
               vEvap_a=fEvaporation(lv_State_A_maf(T%year)) 
               lv_expected=(lv_State_A_maf(T%year)+lv_maf_yr(T%year)-vEvap_a)
              !
              wsa%lvd_PrereleaseExcess_A_maf_yr(T%year)=0
              if(lv_expected <= lv_storageCapacity)then
                if(lv_expected >= li_deadpoolSVT)then               
                  wsa%lvd_ExpStorage_A_maf_yr(T%year)=lv_expected 
                else
                  wsa%lvd_ExpStorage_A_maf_yr(T%year)=li_deadpoolSVT
                endif
              else
                !    
                wsa%lvd_PrereleaseExcess_A_maf_yr(T%year)=lv_expected-lv_storageCapacity
                wsa%lvd_ExpStorage_A_maf_yr(T%year)=lv_storageCapacity 
                !
              endif
              !
          return
        end subroutine expectedStorage
       !------------------------------

        ! ----------------------------
        subroutine passOut(T,wsa,Aout)
           USE gm_TypeControl

           type(watershed_A):: wsa
           type(RiverA)Aout
           type(runTime)T
           ! ============
            !
            if(gvl_start)then
              Aout%gvd_PreReleaseExcess_A_maf=0
              Aout%aPreReleaseExcess=0
            endif
            Aout%gvd_ExpectedStorage_A_maf=wsa%lvd_ExpStorage_A_maf_yr
            Aout%gvd_PreReleaseExcess_A_maf= wsa%lvd_PrereleaseExcess_A_maf_yr
            Aout%aFlow=lv_maf_yr(T%year)
            Aout%aFlowRaw=go_riverFlowSVT
            !
            if(T%year == T%startyear)then
                if(0.6 < wsa%lvd_ExpStorage_A_maf_yr(T%year))then
                  Aout%aAcfta=3.0 
                   gvd_AFperAcreSVT=3.0
                else
                  Aout%aAcfta=2.0 
                   gvd_AFperAcreSVT=2.0
                endif
            endif             !
            !
         return
        end subroutine passOut
        ! --------------------

        ! ----------------------------
        subroutine updateState(T,Aout)
            real, parameter :: cvd_thresh_maf=0.6
            type(RiverA)Aout
            type(runTime)T
            ! ===============
              !
              lv_State_A_maf(T%year+1)=lv_State_A_maf(T%year)
              !
              Aout%aRelease=Aout%gvd_SRP_release_maf_yr(T%year) 
              ! 
              Aout%aPreReleaseExcess=Aout%gvd_PreReleaseExcess_A_maf(T%year)+Aout%gvd_releaseExcess_A_maf_yr(T%year) ! 10.13.09
              !
            ! -------------
               ! Uncertain as to whether this should be T%year or T%year minus 1
               Aout%aAcfta=3.0
              if(lv_State_A_maf(T%year) <= cvd_thresh_maf)Aout%aAcfta=2.0
              gvd_AFperAcreSVT=Aout%aAcfta
              !
            return
        end subroutine updateState
        ! ------------------------

    ! -----------------------
    subroutine outinitialA(T)
      integer :: dt(8)

      type(runTime)T
      ! ===============
        !
        if(gv_dataSVT < 1)gv_dataSVT=1
       if(T%year == T%startyear .and. T%month == 1)then
        call date_and_time(values=dt)
         if(gvl_WriteToDisk)then
          ! -------------------------------------------------------------------------------------
!          write(9,*) "WaterSim-Urban 4.07- Maricopa Inputs"
          write(9,*) "Model Run is:  Year M D  - Time"
          write(9,*) "              ", dt
          write(9,*) ""
          write(9,*) ""
          write(9,*) "                   Salt-Verde-Tonto River Variables                         "
          write(9,*) "----------------------------------------------------------------------------"
         if(2000 < T%year)then
          write(9,*) "INITIAL STORAGE for the SVT River basin (maf): ",lv_State_A_maf(T%year-1), "-",T%year
         else
          write(9,*) "INITIAL STORAGE for the SVT River basin (maf): ",lv_State_A_maf(T%year), "-",T%year
         endif
          write(9,*) "INDEX YEAR for the SVT River basin was:        ",gv_indexyearSVT
          write(9,*) "SVT flow for the year:                         ",li_iflowSVTacft(gv_dataSVT,lv_recordSVT(gv_dataSVT))
          write(9,*) " "
         
          write(9,*) "The CLIMATE FACTOR for the SVT Rivers was:     ",gv_climatefactorSVT
          
        
          write(9,*) "SVT drought factor:                            ",gv_droughtfactorSVT
          write(9,*) "SVT drought year starts:                       ",gv_droughtyearSVT
          write(9,*) "# of drought years:                            ",gv_droughtyearendSVT-gv_droughtyearSVT
         
          write(9,*) ""
          write(9,*) "             Some SVT River constants used in the model"
          write(9,*) " =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  "
          write(9,*) "Normal flow delivery- (ac-ft acre-1):          ",li_normalflowacftperacre
          write(9,*) "Horse Mesa maximum storage (maf):              ",li_horsemesamax
          write(9,*) "Morman Flat maximum storage (maf):             ",li_mormanflatmax
          write(9,*) "Lake Roosevelt maximum storage (maf):          ",li_rooseveltmax
          write(9,*) "Stewart Mountain maximum storage (maf):        ",li_stewartmountainmax
          write(9,*) "Lake Bartlett maximum storage (maf):           ",li_bartlettmax
          write(9,*) "Horseshoe reservior maximum storage (maf):     ",li_horseshoemax
          write(9,*) "Dead pool SVT - (using only one state) (maf):  ",li_deadpoolSVT
          write(9,*) "Storage capacity- SVT combined (maf):          ",lv_storageCapacity
          write(9,*) "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
        !
        endif
       else
       endif
        !
    end subroutine outinitialA
    ! ------------------------

       ! -----------------------------
        subroutine outputsA(T,Aout,gtP)
          use gm_TypeCOntrol

            integer :: i
            real :: ncs_mo(12)
            type(providers) :: gtP
!            type(SVTonto_r) :: SVT_rol
!            type(SVTonto_p) :: SVT_pol
            type(runTime)T
            type(RiverA)Aout
           !=======================
            !
            ! 08.20.10 das added releaseExcess to this variable

            ! Outputs to the interface
            ! 
            go_rechargeSVTsrvReach=NINT((Aout%gvd_PreReleaseExcess_A_maf(T%year)+Aout%gvd_releaseExcess_A_maf_yr(T%year))* (1./gpd_acftTomaf))
            !

            ! THis meaning should change.. 02.13.12 DAS
            go_deliveriesSVT=nint(Aout%gvd_SRP_release_maf_yr(T%year)* (1./gpd_acftTomaf))
            !
            ! 07.27.11- Used (as a lag variable) for county-scale estimates of water for Maricopa (this needs rethinking) 
            gvf_Release=Aout%gvd_SRP_release_maf_yr(T%year)
            !
            if(gpl_validate)then
!              if(gvl_WriteToDisk)&
!              write(3,*)"SVT",T%year,gvf_Release, lv_maf_yr(T%year),lv_State_A_maf(T%year)
            endif

              do i = 1,12,1
               ncs_mo(i)=i*2
              end do
             gtP%av%SVT_po%f_NCS_af_mo=ncs_mo
            !         
            ! Once through the module- write to log file
            ! ==========================================
            if(T%year == T%startyear)then
             if(gvl_WriteToDisk)&
              write(7,*)"  WaterShed_SVT.f90"
            endif
            !
          return
        end subroutine outputsA
       ! ----------------------
End Module lms_River_Aa
! 
    ! -------------------------------
    subroutine sRiver_Aa(T,acft,Aout)
      use gm_Global
      use lms_River_Aa
      !
      integer, intent(in) :: acft

      type(RiverA)Aout
      type(runTime)T
      type(watershed_A):: wsa
      ! =====================
        !
        call aFlow_a(T,acft)
        call aModifyFlow_a(T)
        call expectedStorage(T,wsa)
        call classAdesignations_A(T,Aout)
        call passOut(T,wsa,Aout)
        !
     return
    end subroutine sRiver_Aa
    ! ----------------------

    ! --------------------------
    subroutine sRiver_Ab(T,Aout)
      use gm_Global
      use lms_River_Aa
      !
      type(RiverA)Aout
      type(runTime)T
      type(providers) :: P
      ! ===============
        !
        call updateState(T,Aout)
        call outinitialA(T) 
        call outputsA(T,Aout,P)
        !     
      return
    end subroutine sRiver_Ab
    ! ----------------------
!
! =================================================================================================
! E.O.F